VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CBoDatabase"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'<CAMH>****************************************************************************************
'* Module: CBoDatabase
'* Date  : 28/08/02
'* Author: MartynW
'* $Archive: /Projects/OasysV2/VB/OasysSqlDatabaseCom/CBoDatabase.cls $
'**********************************************************************************************
'* Summary:
'**********************************************************************************************
'* $Revision: 122 $ $Date: 27/05/04 11:43 $ $Author: Richardc $
'* Versions:
'* 29/08/02    mauricem
'*             Header added.
'</CAMH>***************************************************************************************
Option Explicit

Const MODULE_NAME As String = "CBoDatabase"
Implements IBoDatabase

Private m_oSession As ISession
Private m_oRoot    As IOasysRoot
Private m_oSysRoot As ISysRoot
Private m_oConnection As Connection
Private m_oEnterprise As IEnterprise
' An array of FID to CID lookup objects for all the static class table objects,
' indexed by Class Id.
Private m_arrCidLookup(CLASSID_END_OF_STATIC) As CCidLookup
' An array of all tables, for storing CTable objects when we create them
Private m_arrTables(CLASSID_END_OF_STATIC) As CTable
' Last error passed back from IHandler
Private m_eLastError  As enDbErrorType
Private m_retryLimit  As Integer

'----------------------------------------------------------------------------
'----------------------------------------------------------------------------
' For a new Business object, add an entry to each of the following methods.
' We initialise a CTable object for each table with the string parameter
' having the following format.  It comprises a comma-delimited list of items
' that gives table name and property column names which must be in CID sequence.
' The first name in the list is the table name which may optionally have
' parameters within parentheses.  The parameters are a semi-colon-delimited list
' of primary key column names, and each may have parameters within parentheses.
' The second and all subsequent names are data column names (excluding the key
' names), and each may have parameters within parentheses.  A parameter that is
' a number represents an item occurring that number of times.  Occurring column
' names have the base name concatenated with the entry number.
' A key name may have a prameter of A, representing AutoIncrement, where the Db
' sets the next number and we need to return this number back to the original Bo.
'
' For Example: "MYHDR(TKEY(O),KEY2),NUMB,SUPP,ODAT(5),TIME(T),...
' is a table MYHDR that has two keys TKEY (which is autoincrement) and KEY2.  The
' data columns are NUMB, SUPP, ODAT1, ODAT2, ODAT3, ODAT4, ODAT5, TIME.
' TIME is a non-standard time format of char(6).

Private Function CreateTable(nTableId As Integer) As CTable

Const PROCEDURE_NAME = MODULE_NAME & ".CreateTable"

    Call DebugMsg(MODULE_NAME, PROCEDURE_NAME, endlDebug, "Creating Table - ID = " & nTableId)
    Set CreateTable = New CTable
    Select Case nTableId
    Case Is = TABLEID_SUPPLIER
        CreateTable.Initialise nTableId, "SUPMAS(SUPN)," & _
            "NAME,DELC,BBCN,ALPH,HLIN,MERC,TYPE,ODNO,QCTL,QFLG," & _
            "RDNO,DLPO,DLRE,OPON,OPOV,QTYO(5),QTYR(5),LREC(5)," & _
            "LNRE(5),LOVR(5),LUND(5),PREC(5),VREC(5),DYTR(5),DYSH(5)," & _
            "DYLO(5),VPCC"
            
    Case Is = TABLEID_PURCHASEORDER
        CreateTable.Initialise nTableId, "PURHDR(TKEY(A))," & _
            "NUMB,SUPP,ODAT,DDAT,RELN,RAIS,SRCE,HONO,SOQN,NOCR," & _
            "QTYO,VALU,PRFL,NORE,RNUM,PNUM,RCOM,RPAR,DELM,COMM,CONO," & _
            "COMMHO,WGHT,CDAT,CCID,CARR,TIME,RCVD,RCVA,RCVT,RCVC," & _
            "COND,CONA,CONT,CNFC,DELD,DELA,DELT,CNFD,SDAT,EDISTAT"
    Case Is = TABLEID_MENU
        CreateTable.Initialise nTableId, "MenuItems(MenuID(A))," & _
            "MenuText,EXEPath,ASPPath,MasterMenuID,SecurityMask,MenuType," & _
            "ShortKey,MenuIconID,MenuWait,AddPath,GroupID,SendSession,Parameters"
    Case Is = TABLEID_PURCHASEORDERLINE
        CreateTable.Initialise nTableId, "PURLIN(HKEY;LINE)," & _
            "SKUN,ALPH,KDES,PROD,QTYO,PRIC,COST,DLOR,RQTY,WQTB," & _
            "DELE,RNUM,RLIN,RDAT,MESS,QPSU,ONUM,OLIN,CQTY,REAS"
    Case Is = TABLEID_POSHEADER
        CreateTable.Initialise nTableId, "DLTOTS(DATE1;TILL;TRAN)," & _
            "CASH,TIME,TCOD,OPEN,MISC,ORDN,VOID,TMOD," & _
            "PROC,PARK,SUPV,SUSE,VSUP,DSUP,MERC,NMER,TAXA,DISC,TOTL,VATR(9)," & _
            "VSYM(9),XVAT(9),VATV(9),ICOM,ACCN,CARD,AUPD,BACK,IEMP,RCAS,RSUP," & _
            "RMAN,TOCD,PKRC,REMO,GTPN,DESCR,ACCT,DOCN,STOR,CCRD,SSTA,SSEQ,CARD_NO," & _
            "Source,ReceiptBarcode"

    Case Is = TABLEID_POSLINE
        CreateTable.Initialise nTableId, "DLLINE(DATE1;TILL;TRAN;NUMB)," & _
            "SKUN,DEPT,IBAR,QUAN,PRIC,EXTP,EXTC,SPRI,VSYM,RITM,CATA,LREV,PORC,SUPV," & _
            "PRVE,POME,ESEQ,CTGY,GRUP,SGRP,STYL,QSUP,ESEV,IMDN,SALT,VATN,POPD," & _
            "ITAG,TPPD,TPME,QBPD,QBME,DGPD,DGME,MBPD,MBME,HSPD,HSME,ESPD,ESME,VATV," & _
            "BDCO,BDCOInd,RCOD,WEERATE,WEESEQN,WEECOST"
    
    Case Is = TABLEID_POSPAYMENT
        CreateTable.Initialise nTableId, "DLPAID(DATE1;TILL;TRAN;NUMB)," & _
            "TYPE,AMNT,CARD,STDT,EXDT,ISSU,AUTH,CKEY,CKAC,CKSC,CKNO," & _
            "SUPV,SEQN,ECOM,MERC,DIGC,COPN,POST,DBRF,ATYP,CBAM,CTYP," & _
            "CLAS,EFID,EFTC,AUTHDESC,SECCODE,TENC,MPOW,MRAT,TENV,SPARE"
    'Case Is = TABLEID_DISCOUNTRATE
    '   CreateTable.Initialise nTableId, "DISMAS," & _
    '         "DEPT,GROU,SKUN,DISC,SDAT,EDAT,MCOD"
    Case Is = TABLEID_CASHIER
        CreateTable.Initialise nTableId, "CASMAS(CASH)," & _
            "DELC,NAME,POSI,CODE,SUPV,FLOT,SKUL(7),SKUS(7),SKUC(7)," & _
            "PVNO(7),PVVA(7),PSSF,PSNQ(6),PSNC(6),PSNS(6),PSNF(6),PSVS(6)," & _
            "PSVF(6),PSIV(6),PSAV(6),PSCV(6),PSTV(6),PSCA(6)"
    'Case Is = TABLEID_PAYHOURS
    '    CreateTable.Initialise nTableId, "PAYHRS," & _
    '         "STOR,EPAY,CASH,DATE1,WEDT,COMM,HTYP,PHRS,OVTH,ITIM,OTIM,OVTO,HRSA,WHOA"
    Case Is = TABLEID_INVENTORY
        CreateTable.Initialise nTableId, "STKMAS(SKUN)," & _
            "DESCR,VATC,BUYU,SUPP,PROD,PACK,PRIC,PPRI,COST,DSOL,DREC,DORD," & _
            "DPRC,DSET,DOBS,DDEL,ONHA,ONOR,MINI,MAXI,ISTA,IRIS,IRIB,ICAT,IOBS," & _
            "IDEL,ITAG,IWAR,IEAN,SALV1,SALU1,SALV2,SALU2,SALV3,SALU3," & _
            "SALV4,SALU4,SALV5,SALU5,SALV6,SALU6,SALV7,SALU7,CPDO,AWSF,DATS,UWEK," & _
            "FLAG,CFLG,US00(14),DO00(14),WGHT," & _
            "PLUD,IPPC,INON,CYDO,AW13,SQ04,SQ13,SQ01,SQOR,TREQ," & _
            "TREV,TACT,RETQ,RETV,CHKD,LABN,STON,STOQ,SOD1,SOD2," & _
            "SOD3,LABM,LABL,VOLU,NOOR,SUP1,IODT,FODT,PMIN,PMSD," & _
            "PMED,PMCP,SMAN,DFLC,IMCP,TAGF,EQUV,HFIL,REVT,RPRI," & _
            "EQPM,EQPU,MDNQ,WTFQ,AAPC,AADJ,SUP2,WQTY,BALI,WRAT,WSEQ,PRFSKU"
    Case Is = TABLEID_AUDITMASTER
        CreateTable.Initialise nTableId, "AUDMAS," & _
            "SKUN,SQTY,EQTY,FLAG"
    Case Is = TABLEID_STOCKMOVE
        CreateTable.Initialise nTableId, "STKMAS," & _
            "SKUN,MSTQ(4),MSPR(4),MCCV(4),MDRV(4),MREQ(4),MREV(4),MADQ(4),MADV(4)," & _
            "MPVV(4),MIBQ(4),MIBV(4),MRTQ(4),MRTV(4),MBSQ(4),MBSV(4)"
    Case Is = TABLEID_DELNOTEHEADER
        CreateTable.Initialise nTableId, "DRLSUM(NUMB)," & _
            "TYPE,VALU,COST,DATE1,COMM,TKEY,INIT,INFO,0SUP," & _
            "0CON,0PON,0DAT,0REL,0SOQ,0DL(9),0SRC,1STR,1IBT," & _
            "1PRT,1CON,3SUP,3DAT,3PON,3RET,MATF,IDAT,INVN,RVRV," & _
            "IVAL,IVAT,MEMO,MDAT,TDAT,CARVAL,COMMIT1"
    Case Is = TABLEID_DELNOTELINE
        CreateTable.Initialise nTableId, "DRLDET(NUMB;SEQN)," & _
            "SKUN,ALPH,ORDQ,RECQ,ORDP,BDES,BSPC," & _
            "PRIC,COST,IBTQ,RETQ,FOLQ,REAS,POLN,ICHK,QPSU,OVERQTY"
    'Case Is = TABLEID_DEPARTMENT
    '    CreateTable.Initialise nTableId, "DPTMAS," & _
    '         "DEPT,DESCR,SIZED,VATN,COST,SKUL(7),DPTL(7),SKUS(7),DPTS(7),SKUC(7)," & _
    '         "DPTC(7),PVNO(7),PVVA(7),WSVL(6),WLUP(6),WOOS(6),AZPR"
    Case Is = TABLEID_STORE
        CreateTable.Initialise nTableId, "STRMAS," & _
            "NUMB,ADD1,ADD2,ADD3,ADD4,POST,PHON,SFAX,DSOQ,BAND,TOPPS," & _
            "WARE,CTGY,COUNTRYCODE"
    Case Is = TABLEID_RETURNCUST
        CreateTable.Initialise nTableId, "DLRCUS(DATE1;TILL;TRAN;NUMB)," & _
            "NAME,HAD1,HAD2,HAD3,POST,PHON,RCOD,OVAL,OTEN," & _
            "LABL,HNAM,OSTR,ODAT,OTIL,OTRN,ONUM,MOBP,EMAILADDRESS,PHONENUMBERWORK,WEBONO"
    Case Is = TABLEID_SYSTEMNO
        CreateTable.Initialise nTableId, "SYSNUM," & _
            "FKEY,NEXT(20),SIZE(20)"
    Case Is = TABLEID_NIGHTLOG
        CreateTable.Initialise nTableId, "NITLOG," & _
            "DATE1,NSET,TASK,DESCR,PROG,SDAT,STIM,EDAT,ETIM,ADAT,ATIM,JERR,EMES"
    Case Is = TABLEID_NIGHTMASTER
        CreateTable.Initialise nTableId, "NITMAS," & _
            "NSET,TASK,DESCR,PROG,NITE,RETY,WEEK,PEND,LIVE,OPTN,ABOR,JRUN,DAYS(7),BEGD,ENDD"
    'Case Is = TABLEID_SOHEADER
    '    CreateTable.Initialise nTableId, "ORDHDR," & _
    '         "NUMB,CARD,CASH,TILL,CPRE,DNAM,DAD1,DAD2,DAD3,DPST,TEL1,TEL2," & _
    '         "DEPN,DEPV,ICOM,OPRT,OSTA,QDAT,XDAT,ODAT,EDAT,NDEL,COMP,DDAT," & _
    '         "CANC,CDAT,CCAS,TVAL,OVAL,REMA(4),NAME,DISR"
    'Case Is = TABLEID_SOLINE
    '    CreateTable.Initialise nTableId, "ORDDET(NUMB;LINE)," & _
    '         "SKUN,DESCR,SUPP,QORD,SPRI,PRIC,EXTP,EXTC,DISC," & _
    '         "QPSU,ORDS,PONO,NDEL,QSOL,CANC,COMP,REMA,DATE1,DISR,NRSI"
    'Case Is = TABLEID_SOORDERTYPE
    '    CreateTable.Initialise nTableId, "ORDTYP," & _
    '         "TYPE,DESCR,DELC,IORD,QEXP,DOWT,DWOI,DXWI"
    'Case Is = TABLEID_SORANGEDISC
    '    CreateTable.Initialise nTableId, "ORDRNG," & _
    '         "DISP1,DISD1,DIED1"
    'Case Is = TABLEID_SORANGE
    '    CreateTable.Initialise nTableId, "ORDRNG," & _
    '         "TYPE,DEPT,GROU,DELC,IACC,ISKU"
    'Case Is = TABLEID_SORANGEACC
    '    CreateTable.Initialise nTableId, "ORDACC," & _
    '         "RTYP,RDPT,RGRP,DEPT,GROU,DELC"
    Case Is = TABLEID_RETURNHDR
        CreateTable.Initialise nTableId, "RETHDR(TKEY(A))," & _
            "NUMB,SUPP,EDAT,RDAT,PONO,DRLN,VALU,RPRT"
    Case Is = TABLEID_RETURNLINE
        CreateTable.Initialise nTableId, "RETLIN(HKEY;LINE)," & _
            "SKUN,ALPH,QUAN,PRIC,COST,REAS,COMM"
    Case Is = TABLEID_CONSHEADER
        CreateTable.Initialise nTableId, "CONMAS," & _
            "NUMB,PONO,PREL,DONE,EDAT,SUPP,IBTI,IBTS,DNOT(9),INIT1,TIME1,INIT2,TIME2," & _
            "INIT3,TIME3,INIT4,TIME4,INIT5,TIME5,INIT6,TIME6,CNUM"
    'Case Is = TABLEID_TRADER
    '    CreateTable.Initialise nTableId, "TRADERS(CARD)," & _
    '         "NAME,ADD1,ADD2,ADD3,POST,PHON,FAXN,DOPEN,DISC,TURNOVER," & _
    '         "DLSALE,DELC,TYPE,CRAC,CLIM,ABAL,STOP,DLPAID,STOR"
    Case Is = TABLEID_DEPOSIT
        CreateTable.Initialise nTableId, "DEPMAS," & _
            "NUMB,NAME,DATE1,AMNT,IREF,CODE,DONE,TILL,TRAN,CASH,ORDN,TVAL,TOUT,FLAG,CARD,COMMHO"
    Case Is = TABLEID_ISTOUTHEADER
        CreateTable.Initialise nTableId, "DRLSUM," & _
            "NUMB,TYPE,VALU,COST,DATE1,COMM,TKEY,INIT,INFO,0CON,0SRC,1STR,1IBT," & _
            "1PRT,1CON,3PON,MATF,IDAT,INVN,RVRV,IVAL,IVAT,MEMO,MDAT,TDAT,CARVAL,COMMIT1"
    Case Is = TABLEID_ISTLINE
        CreateTable.Initialise nTableId, "DRLDET," & _
            "NUMB,SEQN,SKUN,ALPH,ORDQ,RECQ,ORDP,BDES,BSPC," & _
            "PRIC,COST,IBTQ,RETQ,FOLQ,REAS,POLN,ICHK,QPSU"
    Case Is = TABLEID_STOCKWOF
        CreateTable.Initialise nTableId, "STKWOF(BATCH;SEQN)," & _
            "REAS,SKUN,DATE1,WAUT,DAUT,QUAN,PRIC,COST,INIT,INFO"
    Case Is = TABLEID_STOCKCOUNTHEADER
        CreateTable.Initialise nTableId, "HHTHDR," & _
            "LOCN,NEXT,DONE,DATE1,TIME(T)"
    Case Is = TABLEID_STOCKCOUNTLINE
        CreateTable.Initialise nTableId, "HHTDET(LOCN;SEQN)," & _
            "SKUN,DEPT,COUN,DATE1,TIME,SOLD,DCOU,CDAT"
    Case Is = TABLEID_STOCKADJUST
        CreateTable.Initialise nTableId, "STKADJ(DATE1;CODE;SKUN)," & _
            "COMM,INIT,DEPT,SSTK,QUAN,PRIC,COST," & _
            "TYPE,TSKU,TPRI,TVAL,INFO,DRLN,SEQS,QPSU,INF2,WAUT"
    Case Is = TABLEID_STOCKADJPEND
        CreateTable.Initialise nTableId, "SKADJP," & _
            "SKUN,SSTK,SCOU,OCOU,INFO,APPL,VADJ,VAJR"
    Case Is = TABLEID_STOCKLOCATION
        CreateTable.Initialise nTableId, "LOCSTK(SKUN;LOCN)," & _
            "COUN,DATE1,USER,RFUP,SEQN"
    Case Is = TABLEID_STOCKLOCATION2
        CreateTable.Initialise nTableId, "LOCSEC," & _
            "LOCN,SKUN"
    Case Is = TABLEID_LOCATIONTYPE
        CreateTable.Initialise nTableId, "LOCTYP," & _
            "TYPE,DESCR,IPOS,NLOC"
    Case Is = TABLEID_RELATEDITEM
        CreateTable.Initialise nTableId, "RELITM," & _
            "SPOS,PPOS,NSPP,QTYS,DELC,PTDQ,YTDQ,PYRQ,WTDS,PWKS,WTDM,PWKM,PTDM,PPDM,YTDM,PYRM"
    Case Is = TABLEID_PRICECHANGE
        CreateTable.Initialise nTableId, "PRCCHG(SKUN;PDAT)," & _
            "PRIC,PSTA,SHEL,AUDT,AUAP,MARK,MCOM," & _
            "LABS,LABM,LABL,EVNT,PRIO,EEID,MEID"
    Case Is = TABLEID_EAN
        CreateTable.Initialise nTableId, "EANMAS," & _
            "NUMB,SKUN"
    Case Is = TABLEID_POSACTION
        CreateTable.Initialise nTableId, "POSACT," & _
            "SKUN,LOCA,SELI,FPRI,SPRI,EANS,EANO,POSF1,POSI1,TAGI,SSWL,OSWL,SCOU,OCOU"
    Case Is = TABLEID_POSMESSAGE
        CreateTable.Initialise nTableId, "POSMSG," & _
            "NUMB,TEXT"
    Case Is = TABLEID_STOCKADJCODE
        CreateTable.Initialise nTableId, "SACODE(NUMB)," & _
            "DESCR,TYPE,SIGN,SECL,IMDN,IWTF"
    Case Is = TABLEID_UNITOFMEASURE
        CreateTable.Initialise nTableId, "UOMCTL," & _
            "UOMC,UOMT,DELC"
    Case Is = TABLEID_PRODUCTGROUP
        CreateTable.Initialise nTableId, "GRMGRP," & _
            "DEPT,GROU,SVAL,SCOS"
    Case Is = TABLEID_ITEMGROUP
        CreateTable.Initialise nTableId, "GMRSKU," & _
            "SKUN,DEPT,GROU,SUNT,SVAL,SCOS,HOLD,DOPN,DSTK"
    'Case Is = TABLEID_DEPTGROUP
    '    CreateTable.Initialise nTableId, "DPTGRP," & _
    '         "DEPT,GROU,DESCR,DAYC,WSVL,WLUP,WOOS"
    Case Is = TABLEID_CASHBALANCEHDR
        CreateTable.Initialise nTableId, "CBSHDR(FKEY)," & _
            "DATE1,BANK,GIFT,DEPV,FLOT,DIDN,DODN,KEEP," & _
            "COUN,GVMI,TEND(40),TNUM(40),TDEP(40),TSEQ(40)," & _
            "SLIP(40),MAXS,COU1"
    Case Is = TABLEID_SUPPLIERS
        CreateTable.Initialise nTableId, "SUPMAS(SUPN)," & _
            "NAME,DELC"
            
    Case Is = TABLEID_INVENTORYS
        CreateTable.Initialise nTableId, "STKMAS," & _
            "SKUN,DESCR,DEPT,SUPP,FLAG1,FLAG2,FLAG3,FLAG4,FLAG5,WARE"
    Case Is = TABLEID_DESPATCHMETHOD
        CreateTable.Initialise nTableId, "DESTYP(DTID(A))," & _
            "DESCR,ACTV,REFREQ"
    Case Is = TABLEID_PURHDRNARRATIVE
        CreateTable.Initialise nTableId, "PURNAR," & _
            "STOR,HKEY,TEXT1,TEXT2"
'    Case is = TABLEID_CUSTOMERS
    Case Is = TABLEID_TYPESOFSALECONTROL
        CreateTable.Initialise nTableId, "TOSCTL(TOSC)," & _
            "TOSD,IUSE,UpdateZReads"
    Case Is = TABLEID_TYPESOFSALEOPTIONS
        CreateTable.Initialise nTableId, "TOSOPT(DSEQ)," & _
            "TOSC,TOSD,DOCN,SPRT,OPEN,SPEC,SUPV"
    Case Is = TABLEID_TYPESOFSALETENDERS
        CreateTable.Initialise nTableId, "TOSTEN(DSEQ;TEND)"
    Case Is = TABLEID_TENDERCONTROL
        CreateTable.Initialise nTableId, "TENCTL(TTID)," & _
            "TTDE,IUSE"
    Case Is = TABLEID_TENDEROPTIONS
        CreateTable.Initialise nTableId, "TENOPT(TEND)," & _
            "TTID,TTDE,TTOT,TTCC,TTEF,TODR,TADA,PFOC,PBOC,MINV,MAXV,FLIM,TTDS"
'    Case is = TABLEID_TRADERS
    Case Is = TABLEID_LINECOMMENTS
        CreateTable.Initialise nTableId, "LINENOTE(LNID(A))," & _
            "DESCR,ACTV,TTYPE,LNOTE"
    Case Is = TABLEID_DEPTANALYSIS
        CreateTable.Initialise nTableId, "ABCDPT," & _
            "DEPT,UNIT,VALU,COUN"
    Case Is = TABLEID_VATRATES
        CreateTable.Initialise nTableId, "RETOPT," & _
            "FKEY,VATN,VATR(9)"
    Case Is = TABLEID_SYSTEMDATES
        CreateTable.Initialise nTableId, "SYSDAT(FKEY)," & _
            "DAYS,WEND,OPEN(14),TODT,TODW,TMDT,TMDW,WKDT,WK13(13),LIVE,PSET," & _
            "S1DT(14),S1YR(14),S1PF(14),S2DT(14),S2YR(14),S2PF(14),TIDT,LADT," & _
            "TIYR,PPER,PWEK,NSET,NITE,RETY,CYNO,CYCW,AUDT,DPCA,LDAT"
    Case Is = TABLEID_RETURNCODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,IPER"
    Case Is = TABLEID_PRICEOVERRIDE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,IRPO,SUPV,MANA,IPER,ACTIVE,PMATCH,VALUE1,VALUE2,MFLEX,ISACTIVE"
    Case Is = TABLEID_STOCKLOG
        CreateTable.Initialise nTableId, "STKLOG(TKEY(A))," & _
            "DATE1,TIME,SKUN,TYPE,KEYS,ICOM,EEID,SSTK,SRET,SPRI,SMDN,SWTF," & _
            "ESTK,ERET,EPRI,EMDN,EWTF,DAYN"
    Case Is = TABLEID_ISTINHEADER
        CreateTable.Initialise nTableId, "DRLSUM," & _
            "NUMB,TYPE,VALU,COST,DATE1,COMM,TKEY,INIT,INFO,0CON,0SRC,1STR,1IBT," & _
            "1PRT,1CON,MATF,IDAT,INVN,RVRV,IVAL,IVAT,MEMO,MDAT,TDAT,CARVAL,COMMIT1"
    Case Is = TABLEID_PARAMETER
        CreateTable.Initialise nTableId, "Parameters," & _
            "ParameterID,Description,StringValue,LongValue,BooleanValue,DecimalValue,ValueType"
    Case Is = TABLEID_STOCKTAKE
        CreateTable.Initialise nTableId, "StockTakes(Id(A))," & _
            "State,FreezeDate,AdjustDate,Password"
    Case Is = TABLEID_WORKSTATIONCONFIG
        CreateTable.Initialise nTableId, "WSOCTL," & _
            "WSID,DESCR,PFCT,WACT,TGRP(9),IAFG(99),DLOG,BCOD,TOUCH,QUOTTILL,CSDRAWER,USEEFT,PRNTTYPE"
    Case Is = TABLEID_USER
        CreateTable.Initialise nTableId, "SYSPAS(EEID)," & _
            "NAME,INIT,POSI,EPAY,PASS,DPAS,SUPV," & _
            "AUTH,DAUT,OUTL,IAFG(99),SECL(99),DELC,DDAT,DTIM," & _
            "DWHO,DOUT,TNAM,DFAM,LANG,MANA"
    Case Is = TABLEID_RETAILEROPTIONS
        CreateTable.Initialise nTableId, "RETOPT(FKEY)," & _
            "STOR,SNAM,SAD1,SAD2,SAD3,VATI,TYPE,HCAS," & _
            "KEEP,VDIS,FLOT,MAXC,MAXF,DOLR,DOLU,VATO,SAU5,SAU2,SAU1,SMAX,VATP,MINC," & _
            "SAU3,SAU4,LOAD,PCAA,COUNTRYCODE"
    Case Is = TABLEID_SYSTEMOPTIONS
        CreateTable.Initialise nTableId, "SYSOPT," & _
            "FKEY,STOR,SNAM,HNAM,HAD1,HAD2,HAD3,HAD4,HAD5,HPST,HPHN,HFAX," & _
            "CVAT,MAST,HVIS,MSON,PDAY,ADAY,USTK,IHOS,COSL,ADDS,DCLR,IHHT," & _
            "NCOU,SELC,PCAA,PCDA,PSEL,BLKU,LPFL,CTYP,CGRP,LOCD,REMD,PATH," & _
            "PCOP,MICI,MACI,MACM,MREC,RDAY,PHIE"
    Case Is = TABLEID_COUNTEDSKU
        CreateTable.Initialise nTableId, "HHTDET(SKUN(D))," & _
            "COUN(S),DCOU(S)"
    'Case Is = TABLEID_DELNOTENARRATIVE
    '    CreateTable.Initialise nTableId, "DRLNAR(STOR;DRLN;SKUN;SEQN)," & _
    '         "TEXT1,TEXT2"
    Case Is = TABLEID_RETURNNOTE
        CreateTable.Initialise nTableId, "DRLSUM(NUMB)," & _
            "TYPE,VALU,COST,DATE1,COMM,TKEY,INIT,INFO,3SUP," & _
            "3DAT,3PON,3RET,MATF,IDAT,INVN,RVRV,IVAL,IVAT," & _
            "MEMO,MDAT,TDAT,CARVAL,COMMIT1,0DL1,0DL9,0SUP,0SRC,0REL"
    Case Is = TABLEID_RETURNNOTELINE
        CreateTable.Initialise nTableId, "DRLDET(NUMB;SEQN)," & _
            "SKUN,ALPH,ORDQ,RECQ,ORDP,BDES,BSPC," & _
            "PRIC,COST,IBTQ,RETQ,FOLQ,REAS,POLN,ICHK,QPSU"
    Case Is = TABLEID_SALETOTALS
        CreateTable.Initialise nTableId, "RSFLAS(FKEY(A))," & _
            "FLOT,PICK,NUMB(13),TIME(13),AMNT(13),TTCO(20),TTAM(20)"
    Case Is = TABLEID_TILLTOTALS
        CreateTable.Initialise nTableId, "RSTILL," & _
            "TILL,FTKY,CASH,PCAS,PTIM,NUMB,AMNT,TRAN,ZRED,IEVT"
    Case Is = TABLEID_CASHIERTOTALS
        CreateTable.Initialise nTableId, "RSCASH," & _
            "CASH,FTKY,TILL,NAME,SECC,NUMB,AMNT"
    Case Is = TABLEID_ISTINEDIHEADER
        CreateTable.Initialise nTableId, "SHPHDR(STOR;DRLN)," & _
            "SDAT,RDAT,DATE1,QUAN,VALU,COST," & _
            "RECD,CANC,USER,IQTY,TOCANC,DSNUMB"
    Case Is = TABLEID_ISTINEDILINE
        CreateTable.Initialise nTableId, "SHPDET(STOR;DRLN;SKUN)," & _
            "SEQN,QUAN,IVAL,ICST,QPSU,IQTY"
    Case Is = TABLEID_PURCHASECONSLINE
        CreateTable.Initialise nTableId, "PURCON(HKEY;LINE)," & _
            "PONO,PLIN,ONUM,OLIN,SKUN,PROD,QTYO,PRIC,COST,QPSU,COMP,DATE1"
    Case Is = TABLEID_INVENTORYINFO
        CreateTable.Initialise nTableId, "STKTXT(SKUN;SEQN)," & _
            "INFO"
    Case Is = TABLEID_STOCKADJREASON
        CreateTable.Initialise nTableId, "ADREAS(NUMB;REAS)," & _
            "DESCR"
    Case Is = TABLEID_ACTIVITYLOG
        CreateTable.Initialise nTableId, "ACTLOG(TKEY(A))," & _
            "DATE1,EEID,WSID,AFGN,AFPN,LOGI,FORC,STIM,ETIM,EDAT"
    Case Is = TABLEID_STORESTATUS
        CreateTable.Initialise nTableId, "SYSNID(FKEY)," & _
            "MAST,DATE1,SLAV(31)"
    Case Is = TABLEID_EDIFILECONTROL
        CreateTable.Initialise nTableId, "TCFCTL(FILE)," & _
            "DESCR,LAST,DONE,TYPE,IE2E"
    Case Is = TABLEID_SALESLEDGER
        CreateTable.Initialise nTableId, "SLEDGER(REC-NO(A))," & _
            "STORE,CUST,IDATE,ODATE,PDATE,DDATE,PAID-DATE," & _
            "PERIOD,REF1,ORDN,TYPE,VALT,VALV,VALO,DISP?," & _
            "SPRT?,USER,DCOM,MEMO1,MEMO2"
    Case Is = TABLEID_TCFMASTER
        CreateTable.Initialise nTableId, "TCFMAS(FILE;SEQN)," & _
            "ASEQ,DATE1,CDAT,CTIM,TCNT,ACNT,IE2E,PROC,PDAT," & _
            "PTIM,DONE,DDAT,DTIM,ECOD"
    Case Is = TABLEID_CASHBALANCECONTROL
        CreateTable.Initialise nTableId, "CBSCTL(DATE1)," & _
            "DONE,COMM,INVA(10),OUVA(10),TDEP,TVOU,FLOT,TEND(40),SLIP(40),COM1,COM2,COM3"
    Case Is = TABLEID_CASHBALANCESUMMARY
        CreateTable.Initialise nTableId, "CBSSUM(DATE1)," & _
             "WHEN,BANK,GROS(3),DISC(3),PTOT(3),SAVA(3),SCVA(3),RFVA(3)," & _
            "RCVA(3),MAVA(3),CUST(3),IN01(3),IN02(3),IN03(3),IN04(3),IN05(3)," & _
            "IN06(3),IN07(3),IN08(3),IN09(3),IN10(3),OU01(3),OU02(3),OU03(3)," & _
            "OU04(3),OU05(3),OU06(3),OU07(3),OU08(3),OU09(3),OU10(3),BA01(3)," & _
            "BA02(3),BA03(3),BA04(3),BA05(3),BA06(3),BA07(3),BA08(3),BA09(3)," & _
            "BA10(3),BA11(3),BA12(3),BA13(3),BA14(3),BA15(3),BA16(3),BA17(3)," & _
            "BA18(3),BA19(3),BA20(3),BA21(3),BA22(3),BA23(3),BA24(3),BA25(3)," & _
            "BA26(3),BA27(3),BA28(3),BA29(3),BA30(3),BA31(3),BA32(3),BA33(3)," & _
            "BA34(3),BA35(3),BA36(3),BA37(3),BA38(3),BA39(3),BA40(3),TDEP(3)," & _
            "TVOU(3),FLOT(3),ASAL(3),HORF(3)"
    Case Is = TABLEID_STOCKLEVEL
        CreateTable.Initialise nTableId, "vwFREESTOCK," & _
            "SKUN,DESCR,DEPT,QPUM(5),SUOC,COST,ONHA,ONOR,ONDI,CONO,MINI,MAXI," & _
            "SIZED,FLAG5,FREE"
    Case Is = TABLEID_POLINES
        CreateTable.Initialise nTableId, "vwPOLINES," & _
            "NUMB,SKUN,DELE,ODAT,DDAT"
    Case Is = TABLEID_OPENDRAWERCODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR"
    Case Is = TABLEID_PAIDINCODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ISACTIVE"
    Case Is = TABLEID_PAIDOUTCODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ATTR,SUPV,MANA,ACTIVE,ISACTIVE"
    Case Is = TABLEID_SALESCUSTOMER
        CreateTable.Initialise nTableId, "vwSalesCust," & _
            "DATE1,TILL,TRAN,TIME,TCOD,CNAM,CPST,TOTL,VOID,PARK"
    Case Is = TABLEID_EDICHANGECODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR"
    Case Is = TABLEID_EDIDELHEADER
        CreateTable.Initialise nTableId, "DELHDR(STOR;NUMB;SUPP;DNOT)," & _
            "DDAT,CARR,RCVD,COMM"
    Case Is = TABLEID_EDIDELLINE
        CreateTable.Initialise nTableId, "DELLIN(STOR;NUMB;DNOT;SKUN)," & _
            "DQTY"
    Case Is = TABLEID_EDIPOLINES
        CreateTable.Initialise nTableId, "vwEDIPOLines," & _
            "NUMB,SUPP,DDAT,DDAT,SKUN,DESCR,SIZED,QTYO,CQTY,ONUM,MPRD,RCVD,DQTY,DNOT,RCVD"
    Case Is = TABLEID_EDIPOEARLY
        CreateTable.Initialise nTableId, "vwEDIPOEarly," & _
            "NUMB,SUPP,NAME,DDAT,CDAT"
    Case Is = TABLEID_EDIPOLATE
        CreateTable.Initialise nTableId, "vwEDIPOLate," & _
            "NUMB,SUPP,NAME,DDAT,CDAT"
    Case Is = TABLEID_EDIPOQTYDISCREPANCY
        CreateTable.Initialise nTableId, "vwEDIPOQtyDiscr," & _
            "NUMB,SUPP,NAME,DDAT,CDAT"
    Case Is = TABLEID_EDIPOQTYDISCREPANCYLINES
        CreateTable.Initialise nTableId, "vwEDIPOQtyDiscrLine," & _
            "NUMB,SUPP,NAME,DDAT,CDAT,SKUN,DESCR,SIZED,QTYO,CQTY,DISCR"
    Case Is = TABLEID_TRANSACTION_DISCOUNT
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ATTR,LABL"
    Case Is = TABLEID_GROSSMARGINS
        CreateTable.Initialise nTableId, "GMRSKU(SKUN)," & _
            "DEPT,GROU,SUNT(6),SVAL(6),SCOS(6),HOLD(6),DOPN(6),DSTK(6)"
    'Case Is = TABLEID_ITEMMESSAGES
    '    CreateTable.Initialise nTableId, "STKPRM(IPRM)," & _
    '         "DESCR,AGEP"
    Case Is = TABLEID_CARDINFO
        CreateTable.Initialise nTableId, "DLPEFT," & _
            "DATE1,TILL,TRAN,NUMB,TYPE,TRK2"
    Case Is = TABLEID_OPMASTER
        CreateTable.Initialise nTableId, "EVTMAS(TYPE;KEY1;NUMB;PRIO;KEY2)," & _
            "PDIS,IDEL,IDOW,SDAT,EDAT,PRIC,BQTY,GQTY,VDIS,BUYCPN,GETCPN,SPARE"
    Case Is = TABLEID_OPHEADER
        CreateTable.Initialise nTableId, "EVTHDR(NUMB)," & _
            "PRIO,DESCR,SDAT,STIM,EDAT,ETIM,DACT(7),IDEL"
    Case Is = TABLEID_OPDEALGROUP
        CreateTable.Initialise nTableId, "EVTDLG(NUMB;DLGN;TYPE;KEY1)," & _
            "IDEL,QUAN,VERO,PERO"
    Case Is = TABLEID_OPMIXMATCH
        CreateTable.Initialise nTableId, "EVTMMG(MMGN;SKUN)," & _
            "IDEL"
    Case Is = TABLEID_CASHIERCASHBAL
        CreateTable.Initialise nTableId, "CBSCAS(DATE1;NUMB)," & _
            "GROS,DISC,COUN(8),AMNT(8),DISA(8),FLOT,PTOT,STTC(40)," & _
            "STTA(40),PKUP(40)"
    Case Is = TABLEID_PRICECUSINFO
        CreateTable.Initialise nTableId, "DLOCUS(DATE1;TILL;TRAN)," & _
            "NAME,ADD1,ADD2,ADD3,ADD4,POST,PHON"
    Case Is = TABLEID_POSEVENTLINE
        CreateTable.Initialise nTableId, "DLEVNT(DATE1;TILL;TRAN;NUMB;ESEQ)," & _
            "TYPE,AMNT"
    Case Is = TABLEID_PRICELINEINFO
        CreateTable.Initialise nTableId, "DLOLIN(DATE1;TILL;TRAN;NUMB)," & _
            "CNAM,CAD1,CAD2,CAD3,CAD4,CPST,CPHN,CFAX,EPRI," & _
            "EVAT,CPRI,PREV,OSTR,OTIL,OTRN,ODAT,OPRI"
    Case Is = TABLEID_HIERARCHYCATEGORY
        CreateTable.Initialise nTableId, "HIECAT," & _
            "NUMB,DESCR,ALPH"
    Case Is = TABLEID_HIERARCHYGROUP
        CreateTable.Initialise nTableId, "HIEGRP," & _
            "NUMB,GROU,DESCR,ALPH"
    Case Is = TABLEID_HIERARCHYSUBGROUP
        CreateTable.Initialise nTableId, "HIESGP," & _
            "NUMB,GROU,SGRP,DESCR,ALPH"
    Case Is = TABLEID_HIERARCHYSTYLE
        CreateTable.Initialise nTableId, "HIESTY," & _
            "NUMB,GROU,SGRP,STYL,DESCR,ALPH"
    Case Is = TABLEID_INVENTORYWICKES
        CreateTable.Initialise nTableId, "STKMAS(SKUN)," & _
            "CTGY,GRUP,SGRP,STYL,IOFF,ISOL,QUAR,IPRD,SALT,IPSK,TIMB"
    Case Is = TABLEID_POSMISSINGEAN
        CreateTable.Initialise nTableId, "DLANAS(DATE1;TILL;TRAN;NUMB;SEQN)," & _
            "EANN"
    Case Is = TABLEID_REFUNDCODE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ATTR,LABL,ISACTIVE"
    Case Is = TABLEID_TENDEROVERRIDE
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ATTR,LABL"
    Case Is = TABLEID_ZREADS
        CreateTable.Initialise nTableId, "ZREADS(WSID;TYPE;STYP)," & _
            "COUN,AMNT"
    Case Is = TABLEID_POSGIFTVOUCHERS
        CreateTable.Initialise nTableId, "DLGIFT(DATE1;TILL;TRAN;LINE;SERI)," & _
            "EEID,TYPE,AMNT,COMM"
    Case Is = TABLEID_CUSTORDERHEADER
        CreateTable.Initialise nTableId, "CORHDR(NUMB)," & _
            "CUST,DATE1,CANC,DELI,DELD,DELC,AMDT,ADDR1,ADDR2,ADDR3,ADDR4,PHON," & _
            "PRNT,RPRN,REVI,MVST,DCST,QTYO,QTYT,QTYR,WGHT,VOLU,SDAT,STIL,STRN," & _
            "RDAT,RTIL,RTRN,MOBP,POST,NAME,OEID,DDAT"
    Case Is = TABLEID_CUSTORDERLINE
        CreateTable.Initialise nTableId, "CORLIN(NUMB;LINE)," & _
            "SKUN,QTYO,QTYT,QTYR,WGHT,VOLU,PORC,DELIVERYSTATUS,SELLINGSTOREID,SELLINGSTOREORDERID," & _
            "QTYTOBEDELIVERED,DELIVERYSOURCE,DELIVERYSOURCEIBTOUT,SELLINGSTOREIBTIN," & _
            "PRICE,ISDELIVERYCHARGEITEM"
    Case Is = TABLEID_GIFTVOUCHERHOTFILE
        CreateTable.Initialise nTableId, "GIFHOT(SERI)," & _
            "TEXT,HOTT,COMM"
    Case Is = TABLEID_EVENTHSEXCLUSIONS
        CreateTable.Initialise nTableId, "EVTHEX(NUMB;HIER;ITEM)," & _
            "IDEL"
    Case Is = TABLEID_COLLEAGUECARDHOTFILE
        CreateTable.Initialise nTableId, "COLHOT(NUMB)," & _
            "DATE1"
    Case Is = TABLEID_QUOTEHEADER
        CreateTable.Initialise nTableId, "QUOHDR(NUMB)," & _
            "CUST,DATE1,CANC,EXPD,SOLD,DELI,MVST,DCST,WGHT,VOLU,QDAT,QTIL,QTRN,CARD_NO,FOCDEL"
    Case Is = TABLEID_QUOTELINE
        CreateTable.Initialise nTableId, "QUOLIN(NUMB;LINE)," & _
            "SKUN,QUAN,WGHT,VOLU"
    Case Is = TABLEID_CUSTOMER
        CreateTable.Initialise nTableId, "CUSMAS(CUST)," & _
            "ALPH,TITL,INIT,SNAM,ADDR1,ADDR2,ADDR3,ADDR4,POST,PHON1,PHON2,PHON3," & _
            "ANSW1,ANSW2,ANSW3,ANSW4,ANSW5,ANSW6,ANSW7,ANSW8,ANSW9,ANSW10,DELI"
    Case Is = TABLEID_WEBEVENT
        CreateTable.Initialise nTableId, "WEBEVNT(DATE1;TILL;TRAN;NUMB;ESEQ)," & _
            "TYPE,AMNT"
    Case Is = TABLEID_WEBHEADER
        CreateTable.Initialise nTableId, "WEBTOTS(DATE1;TILL;TRAN)," & _
            "CASH,TIME,SUPV,TCOD,OPEN,MISC,DESCR,ORDN,OORD,ACCT,VOID,VSUP,TMOD," & _
            "PROC,DOCN,SUSE,STOR,MERC,NMER,TAXA,DISC,DSUP,TOTL,ACCN,CARD,AUPD," & _
            "BACK,ICOM,IEMP,RCAS,RSUP,VATR(9),VSYM(9),XVAT(9),VATV(9),PARK," & _
            "RMAN,TOCD,PKRC,REMO,GTPN,COLN,STAT,RCVD,RCVT,DCVD,DEEI,HCVD,HEEI," & _
            "CMNT,TYPE,CAND,CANB,CARD_NO"
    Case Is = TABLEID_WEBLINE
        CreateTable.Initialise nTableId, "WEBLINE(DATE1;TILL;TRAN;NUMB)," & _
            "SKUN,DEPT,IBAR,SUPV,QUAN,SPRI,PRIC,PRVE,EXTP,EXTC,RITM,PORC,ITAG,CATA,VSYM," & _
            "TPPD,TPME,POPD,POME,QBPD,QBME,DGPD,DGME,MBPD,MBME,HSPD,HSME,ESPD,ESME,LREV,ESEQ," & _
            "CTGY,GRUP,SGRP,STYL,QSUP,ESEV,IMDN,SALT,VATN,VATV,BDCO"
    Case Is = TABLEID_WEBPICK
        CreateTable.Initialise nTableId, "WEBPICK(ORDN;SKUN;SEQN)," & _
            "QTY,EEID,DATE1,TIME"
    Case Is = TABLEID_WEBPAID
        CreateTable.Initialise nTableId, "WEBPAID(DATE1;TILL;TRAN;NUMB)," & _
            "TYPE,AMNT,CARD,EXDT,COPN,CLAS,AUTH,CKEY,SUPV,POST,CKAC," & _
            "CKSC,CKNO,DBRF,SEQN,ISSU,ATYP,MERC,CBAM,DIGC,ECOM,CTYP"
    Case Is = TABLEID_PROMPT
        CreateTable.Initialise nTableId, "PROMPTS(PROMPTID)," & _
            "PROMPTTYPE,IMAGEPATH,SCREENTEXT1,SCREENTEXT2,SCREENTEXT3,SCREENTEXT4," & _
            "PRINTTEXT1,PRINTTEXT2,PRINTTEXT3,PRINTTEXT4,REJECTTEXT1,REJECTTEXT2,DATAITEM," & _
            "DATAGROUP,CONDITION,SUPV,MANA,COLLECT,SALE,PROMPTGROUP,PROMPTVALUE,RESPONSETYPE"
    Case Is = TABLEID_GROUP_PROMPT
        CreateTable.Initialise nTableId, "GROUPPROMPTS(GROUPID;PROMPTID;SEQUENCE)," & _
            "OKGOTO,YESGOTO,NOGOTO,LOGREJECT,GROUPDESC"
    Case Is = TABLEID_ITEM_GRPPROMPT
        CreateTable.Initialise nTableId, "ITEMPROMPTS(SKUN;GROUPPROMPTID;SEQUENCE)," & _
            "SENT,DATEDELETED"
    Case Is = TABLEID_PIM_ITEM
        CreateTable.Initialise nTableId, "PIMMAS(SKUN)," & _
            "CategoryCode,CategoryDescr,GroupCode,GroupDescr,SubGroupCode,SubGroupDescr," & _
            "StyleCode,StyleDescr"
    Case Is = TABLEID_COLLEAGUECARD
        CreateTable.Initialise nTableId, "COLCWI(COLN)," & _
            "COL_NAME,COL_ADD1,COL_ADD2,COL_ADD3,COL_ADD4,COL_POST,COL_SECURE,COL_DELE"
    Case Is = TABLEID_TEMPFIL
        CreateTable.Initialise nTableId, "TMPFIL(TKEY)," & _
            "WSID,FKEY,DATE1,DATA,DAT1,DAT2,DAT3,DAT4"
    Case Is = TABLEID_CURRENCY
        CreateTable.Initialise nTableId, "SYSCUR(CURR)," & _
        "CURD,MAXD,DELC,LDOM,MINT,SAFE,TEND(20),IEPC,CurrencySymbol,PrintSymbol," & _
        "ActiveDate,InactiveDate,SysDefaultCurr,MaxAccepted,Denom(20),DenTxt(20),DenSeq(20)"
    Case Is = TABLEID_EXCHANGERATE
        CreateTable.Initialise nTableId, "EXRATE(CURR)," & _
            "EFFD,RATE,POWR,COMM,MINC,IMIN"
    Case Is = TABLEID_WEEE_RATE
        CreateTable.Initialise nTableId, "WEEECOS(TYPE;SEQN)," & _
            "DESCR,COST"
    Case Is = TABLEID_PLANGRAM
        CreateTable.Initialise nTableId, "PLANGRAM(STORE;PLANNO;PLANSEGN;SKUN)," & _
            "PLANNAME,FIXTURENO,FACINGS,DELE,CAPACITY,PACK,FIXTSEQN"
    Case Is = TABLEID_BARCODEFAILED
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,ATTR,SUPV,MANA,ACTIVE"
    Case Is = TABLEID_EAN_CHECK
        CreateTable.Initialise nTableId, "DLEANCHK(TKEY(A))," & _
            "DATE1,TILL,TRAN,SEQN,TIME,ENTRY,REASONCODE,KREASON,ITEM,TYPE," & _
            "EEID,EAFOUND,EASKUN,EASKUFOUND,SKUN"
    Case Is = TABLEID_TRANREJECT
        CreateTable.Initialise nTableId, "DLREJECT(DATE1;TILL;TRAN;SEQN)," & _
            "EEID,SKUN,REJECTTEXT,GROUPID,PROMPTID"
    Case Is = TABLEID_LINEREVERSAL
        CreateTable.Initialise nTableId, "SYSCOD(TYPE;CODE)," & _
            "DESCR,IRPO,SUPV,MANA,ACTIVE"
    Case Is = TABLEID_DTF_SEND
        CreateTable.Initialise nTableId, "TFWork(MessageID(A))," & _
            "MessageType,MessageDesc,ToStore,MasterKey,MasterApp,DateAdded,NoAttempts," & _
            "LastAttempt,DateSent,Completed"
    Case Is = TABLEID_CARD_SCHEME
        CreateTable.Initialise nTableId, "CARD_SCHEME(ID)," & _
            "SCHEME_NAME,RECEIPT_TEXT,CARD_NO_SIZE,START_NO,END_NO," & _
            "START_DATE,END_DATE,DELETED,KEYED,CAPT_NAME,CAPT_ADD1,CAPT_ADD2,CAPT_ADD3,CAPT_ADD4," & _
            "CAPT_POST,COPY_RECEIPT,EROSION_CODE,DISCOUNT,CARD_PREF,SUPAUTHLEVEL,MNGRAUTHLEVEL," & _
            "PRINT_SIG_SLIP"
    Case Is = TABLEID_CARD_LIST
        CreateTable.Initialise nTableId, "CARD_LIST(CARD_NO)," & _
            "CUST_NAME,CUST_ADD1,CUST_ADD2,CUST_ADD3,CUST_ADD4," & _
            "CUST_POST,HIDE_ADDR,DELETED"
    Case Is = TABLEID_ORDERTEXT
        CreateTable.Initialise nTableId, "CORTXT(NUMB;TYPE;LINE)," & _
            "TEXT,SELLINGSTOREID,SELLINGSTOREORDERID"
    Case Is = TABLEID_CUSTORDERINFO
        CreateTable.Initialise nTableId, "CORHDR4(NUMB)," & _
            "DATE1,DELD,NAME,CUST,DDAT,OEID,FDID,DELIVERYSTATUS,SELLINGSTOREID," & _
            "SELLINGSTOREORDERID,CUSTOMERADDRESS1,CUSTOMERADDRESS2,CUSTOMERADDRESS3," & _
            "CUSTOMERADDRESS4,OMORDERNUMBER,CUSTOMERPOSTCODE,CUSTOMEREMAIL,PHONENUMBERWORK,REFUNDSTATUS"
    Case Is = TABLEID_SUPPLIERDET
        CreateTable.Initialise nTableId, "SUPDET(SUPN)," & _
            "TYPE,DEPO,DELC,TNET,BBCC,VLED(7),LEAD,SOQF"
    Case Is = TABLEID_MARKDOWNSTOCK
        CreateTable.Initialise nTableId, "MARKDOWNSTOCK(SKUNumber;Serial)," & _
        "Price,IsLabelled,DateCreated,DateWrittenOff,DateLastRollover,WeekNumber," & _
        "ReductionWeek(10),ReasonCode,SoldDate,SoldTill,SoldTransaction"
    Case Is = TABLEID_CONRESHEADER
        CreateTable.Initialise nTableId, "ConcernResHeader(StoreID;TransactionDate;TransactionTill;TransactionNumber)," & _
        "Contact1Salutation,Contact1Firstname,Contact1Surname,CompanyName,PostCode,HouseNumberName," & _
        "AddressLine1,AddressLine2,Town,County,Country,ReasonCode,ConcernDescription(4),EmployeeId,RTI"
    Case Is = TABLEID_CONRESDETAIL
        CreateTable.Initialise nTableId, "ConcernResDetail(StoreID;TransactionDate;TransactionTill;TransactionNumber)," & _
        "ItemSequence,PartCode,Quantity,RTI"
    Case Is = TABLEID_COUPONFMT
        CreateTable.Initialise nTableId, "COUPONMASTER(COUPONID)," & _
        "DESCRIPTION,STOREGEN,SERIALNO,EXCCOUPON,REUSABLE,COLLECTINFO,DELETED"
    Case Is = TABLEID_SOLDCOUPON
        'if m_oSession.Root.
        Dim rs As New ADODB.Recordset
        
        Set rs = m_oConnection.Execute("Exec SystemGetParameter 983351")
        If rs.BOF = False Then
            If rs.Fields("BooleanValue") = True Then
                CreateTable.Initialise nTableId, "DLCOUPON(TranDate;TranTillID;TranNo)," & _
                "COUPONID,SEQUENCE,STATUS,EXCCOUPON,MARKETREF,REUSABLE,ISSUESTORENO,SERIALNO,MANAGERID,RTI"
            Else
                CreateTable.Initialise nTableId, "DLCOUPON(StoreID;TranDate;TranTillID;TranNo)," & _
                "COUPONID,SEQUENCE,STATUS,EXCCOUPON,MARKETREF,REUSABLE,ISSUESTORENO,SERIALNO,MANAGERID,RTIFLAG"
            End If
        Else
            CreateTable.Initialise nTableId, "DLCOUPON(StoreID;TranDate;TranTillID;TranNo)," & _
            "COUPONID,SEQUENCE,STATUS,EXCCOUPON,MARKETREF,REUSABLE,ISSUESTORENO,SERIALNO,MANAGERID,RTIFLAG"
        End If
        
    Case Is = TABLEID_DAYPRICE
        CreateTable.Initialise nTableId, "DAYPRICE(SKUN;DATECREATED)," & _
        "TIMECREATED,NEWPRICE,AUTHID,COMMENT"
    Case Is = TABLEID_COUPONTEXT
        CreateTable.Initialise nTableId, "COUPONTEXT(COUPONID;SEQUENCENO)," & _
        "PRINTSIZE,TEXTALIGN,PRINTTEXT,DELETED"
    Case Is = TABLEID_POSPAYMENTCOMM
        CreateTable.Initialise nTableId, "DLCOMM(DATE1;TILL;TRAN;NUMB)," & _
        "TOKENID,CNHASH,RTI,SPARE"
    Case Is = TABLEID_CUST_REFUND
        CreateTable.Initialise nTableId, "CORREFUND(NUMB;LINE;RefundStoreId;RefundDate;RefundTill;RefundTransaction)," & _
            "RefundStatus,SellingStoreIbtOut,QtyReturned,QtyCancelled,FulfillingStoreIbtIn"
    Case Else
        Set CreateTable = Nothing
        Err.Raise OASYS_ERR_BO_CLASS_INCOMPLETE, "CBoDatabase::CreateTable()", _
                "CBoDatabase::CreateTable()" & vbCrLf & "No Table details for Table Id: " & nTableId
    End Select
End Function

' For a new Business object, add an entry to the following method.

Private Function CreateCidLookup(nClassId As Integer) As CCidLookup
    Set CreateCidLookup = New CCidLookup
    Select Case nClassId
    Case Is = CLASSID_SUPPLIER
        CreateCidLookup.Initialise FID_SUPPLIER_END_OF_STATIC, TABLEID_SUPPLIER
    Case Is = CLASSID_PURCHASEORDER
        CreateCidLookup.Initialise FID_PURCHASEORDER_END_OF_STATIC, TABLEID_PURCHASEORDER
    Case Is = CLASSID_MENU
        CreateCidLookup.Initialise FID_MENU_END_OF_STATIC, TABLEID_MENU
    Case Is = CLASSID_PURCHASEORDERLINE
        CreateCidLookup.Initialise FID_PURCHASEORDERLINE_END_OF_STATIC, TABLEID_PURCHASEORDERLINE
    Case Is = CLASSID_POSHEADER
        CreateCidLookup.Initialise FID_POSHEADER_END_OF_STATIC, TABLEID_POSHEADER
    Case Is = CLASSID_POSLINE
        CreateCidLookup.Initialise FID_POSLINE_END_OF_STATIC, TABLEID_POSLINE
    Case Is = CLASSID_POSPAYMENT
        CreateCidLookup.Initialise FID_POSPAYMENT_END_OF_STATIC, TABLEID_POSPAYMENT
    'Case Is = CLASSID_DISCOUNTRATE
    '    CreateCidLookup.Initialise FID_DISCOUNTRATE_END_OF_STATIC, TABLEID_DISCOUNTRATE
    Case Is = CLASSID_CASHIER
        CreateCidLookup.Initialise FID_CASHIER_END_OF_STATIC, TABLEID_CASHIER
    'Case Is = CLASSID_PAYHOURS
    '    CreateCidLookup.Initialise FID_PAYHOURS_END_OF_STATIC, TABLEID_PAYHOURS
    Case Is = CLASSID_INVENTORY
        CreateCidLookup.Initialise FID_INVENTORY_END_OF_STATIC, TABLEID_INVENTORY
    Case Is = CLASSID_AUDITMASTER
        CreateCidLookup.Initialise FID_AUDITMASTER_END_OF_STATIC, TABLEID_AUDITMASTER
    Case Is = CLASSID_STOCKMOVE
        CreateCidLookup.Initialise FID_STOCKMOVE_END_OF_STATIC, TABLEID_STOCKMOVE
    Case Is = CLASSID_DELNOTEHEADER
        CreateCidLookup.Initialise FID_DELNOTEHEADER_END_OF_STATIC, TABLEID_DELNOTEHEADER
    Case Is = CLASSID_DELNOTELINE
        CreateCidLookup.Initialise FID_DELNOTELINE_END_OF_STATIC, TABLEID_DELNOTELINE
    'Case Is = CLASSID_DEPARTMENT
    '    CreateCidLookup.Initialise FID_DEPARTMENT_END_OF_STATIC, TABLEID_DEPARTMENT
    Case Is = CLASSID_STORE
        CreateCidLookup.Initialise FID_STORE_END_OF_STATIC, TABLEID_STORE
    Case Is = CLASSID_RETURNCUST
        CreateCidLookup.Initialise FID_RETURNCUST_END_OF_STATIC, TABLEID_RETURNCUST
    Case Is = CLASSID_SYSTEMNO
        CreateCidLookup.Initialise FID_SYSTEMNO_END_OF_STATIC, TABLEID_SYSTEMNO
    Case Is = CLASSID_NIGHTLOG
        CreateCidLookup.Initialise FID_NIGHTLOG_END_OF_STATIC, TABLEID_NIGHTLOG
    Case Is = CLASSID_NIGHTMASTER
        CreateCidLookup.Initialise FID_NIGHTMASTER_END_OF_STATIC, TABLEID_NIGHTMASTER
    'Case Is = CLASSID_SOHEADER
    '    CreateCidLookup.Initialise FID_SOHEADER_END_OF_STATIC, TABLEID_SOHEADER
    'Case Is = CLASSID_SOLINE
    '    CreateCidLookup.Initialise FID_SOLINE_END_OF_STATIC, TABLEID_SOLINE
    'Case Is = CLASSID_SOORDERTYPE
    '    CreateCidLookup.Initialise FID_SOORDERTYPE_END_OF_STATIC, TABLEID_SOORDERTYPE
    'Case Is = CLASSID_SORANGEDISC
    '    CreateCidLookup.Initialise FID_SORANGEDISC_END_OF_STATIC, TABLEID_SORANGEDISC
    'Case Is = CLASSID_SORANGE
    '    CreateCidLookup.Initialise FID_SORANGE_END_OF_STATIC, TABLEID_SORANGE
    'Case Is = CLASSID_SORANGEACC
    '    CreateCidLookup.Initialise FID_SORANGEACC_END_OF_STATIC, TABLEID_SORANGEACC
    Case Is = CLASSID_RETURNHDR
        CreateCidLookup.Initialise FID_RETURNHDR_END_OF_STATIC, TABLEID_RETURNHDR
    Case Is = CLASSID_RETURNLINE
        CreateCidLookup.Initialise FID_RETURNLINE_END_OF_STATIC, TABLEID_RETURNLINE
    Case Is = CLASSID_CONSHEADER
        CreateCidLookup.Initialise FID_CONSHEADER_END_OF_STATIC, TABLEID_CONSHEADER
    'Case Is = CLASSID_TRADER
    '    CreateCidLookup.Initialise FID_TRADER_END_OF_STATIC, TABLEID_TRADER
    Case Is = CLASSID_DEPOSIT
        CreateCidLookup.Initialise FID_DEPOSIT_END_OF_STATIC, TABLEID_DEPOSIT
    Case Is = CLASSID_ISTOUTHEADER
        CreateCidLookup.Initialise FID_ISTOUTHEADER_END_OF_STATIC, TABLEID_ISTOUTHEADER
    Case Is = CLASSID_ISTLINE
        CreateCidLookup.Initialise FID_ISTLINE_END_OF_STATIC, TABLEID_ISTLINE
    Case Is = CLASSID_STOCKWOF
        CreateCidLookup.Initialise FID_STOCKWOF_END_OF_STATIC, TABLEID_STOCKWOF
    Case Is = CLASSID_STOCKCOUNTHEADER
        CreateCidLookup.Initialise FID_STOCKCOUNTHEADER_END_OF_STATIC, TABLEID_STOCKCOUNTHEADER
    Case Is = CLASSID_STOCKCOUNTLINE
        CreateCidLookup.Initialise FID_STOCKCOUNTLINE_END_OF_STATIC, TABLEID_STOCKCOUNTLINE
    Case Is = CLASSID_STOCKADJUST
        CreateCidLookup.Initialise FID_STOCKADJUST_END_OF_STATIC, TABLEID_STOCKADJUST
    Case Is = CLASSID_STOCKADJPEND
        CreateCidLookup.Initialise FID_STOCKADJPEND_END_OF_STATIC, TABLEID_STOCKADJPEND
    Case Is = CLASSID_STOCKLOCATION
        CreateCidLookup.Initialise FID_STOCKLOCATION_END_OF_STATIC, TABLEID_STOCKLOCATION
    Case Is = CLASSID_STOCKLOCATION2
        CreateCidLookup.Initialise FID_STOCKLOCATION2_END_OF_STATIC, TABLEID_STOCKLOCATION2
    Case Is = CLASSID_LOCATIONTYPE
        CreateCidLookup.Initialise FID_LOCATIONTYPE_END_OF_STATIC, TABLEID_LOCATIONTYPE
    Case Is = CLASSID_RELATEDITEM
        CreateCidLookup.Initialise FID_RELATEDITEM_END_OF_STATIC, TABLEID_RELATEDITEM
    Case Is = CLASSID_PRICECHANGE
        CreateCidLookup.Initialise FID_PRICECHANGE_END_OF_STATIC, TABLEID_PRICECHANGE
    Case Is = CLASSID_EAN
        CreateCidLookup.Initialise FID_EAN_END_OF_STATIC, TABLEID_EAN
    Case Is = CLASSID_POSACTION
        CreateCidLookup.Initialise FID_POSACTION_END_OF_STATIC, TABLEID_POSACTION
    Case Is = CLASSID_POSMESSAGE
        CreateCidLookup.Initialise FID_POSMESSAGE_END_OF_STATIC, TABLEID_POSMESSAGE
    Case Is = CLASSID_STOCKADJCODE
        CreateCidLookup.Initialise FID_STOCKADJCODE_END_OF_STATIC, TABLEID_STOCKADJCODE
    Case Is = CLASSID_UNITOFMEASURE
        CreateCidLookup.Initialise FID_UNITOFMEASURE_END_OF_STATIC, TABLEID_UNITOFMEASURE
    Case Is = CLASSID_PRODUCTGROUP
        CreateCidLookup.Initialise FID_PRODUCTGROUP_END_OF_STATIC, TABLEID_PRODUCTGROUP
    Case Is = CLASSID_ITEMGROUP
        CreateCidLookup.Initialise FID_ITEMGROUP_END_OF_STATIC, TABLEID_ITEMGROUP
    'Case Is = CLASSID_DEPTGROUP
    '    CreateCidLookup.Initialise FID_DEPTGROUP_END_OF_STATIC, TABLEID_DEPTGROUP
    Case Is = CLASSID_CASHBALANCEHDR
        CreateCidLookup.Initialise FID_CASHBALANCEHDR_END_OF_STATIC, TABLEID_CASHBALANCEHDR
    Case Is = CLASSID_SUPPLIERS
        CreateCidLookup.Initialise FID_SUPPLIERS_END_OF_STATIC, TABLEID_SUPPLIERS
    Case Is = CLASSID_INVENTORYS
        CreateCidLookup.Initialise FID_INVENTORYS_END_OF_STATIC, TABLEID_INVENTORYS
    Case Is = CLASSID_DESPATCHMETHOD
        CreateCidLookup.Initialise FID_DESPATCHMETHOD_END_OF_STATIC, TABLEID_DESPATCHMETHOD
    Case Is = CLASSID_PURHDRNARRATIVE
        CreateCidLookup.Initialise FID_PURHDRNARRATIVE_END_OF_STATIC, TABLEID_PURHDRNARRATIVE
    'Case Is = CLASSID_CUSTOMERS
    '    CreateCidLookup.Initialise FID_CUSTOMERS_END_OF_STATIC, TABLEID_CUSTOMERS
    Case Is = CLASSID_TYPESOFSALECONTROL
        CreateCidLookup.Initialise FID_TYPESOFSALECONTROL_END_OF_STATIC, TABLEID_TYPESOFSALECONTROL
    Case Is = CLASSID_TYPESOFSALEOPTIONS
        CreateCidLookup.Initialise FID_TYPESOFSALEOPTIONS_END_OF_STATIC, TABLEID_TYPESOFSALEOPTIONS
    Case Is = CLASSID_TYPESOFSALETENDERS
        CreateCidLookup.Initialise FID_TYPESOFSALETENDERS_END_OF_STATIC, TABLEID_TYPESOFSALETENDERS
    Case Is = CLASSID_TENDERCONTROL
        CreateCidLookup.Initialise FID_TENDERCONTROL_END_OF_STATIC, TABLEID_TENDERCONTROL
    Case Is = CLASSID_TENDEROPTIONS
        CreateCidLookup.Initialise FID_TENDEROPTIONS_END_OF_STATIC, TABLEID_TENDEROPTIONS
    'Case Is = CLASSID_TRADERS
    '    CreateCidLookup.Initialise FID_TRADERS_END_OF_STATIC, TABLEID_TRADERS
    Case Is = CLASSID_LINECOMMENTS
        CreateCidLookup.Initialise FID_LINECOMMENTS_END_OF_STATIC, TABLEID_LINECOMMENTS
    Case Is = CLASSID_DEPTANALYSIS
        CreateCidLookup.Initialise FID_DEPTANALYSIS_END_OF_STATIC, TABLEID_DEPTANALYSIS
    Case Is = CLASSID_VATRATES
        CreateCidLookup.Initialise FID_VATRATES_END_OF_STATIC, TABLEID_VATRATES
    Case Is = CLASSID_SYSTEMDATES
        CreateCidLookup.Initialise FID_SYSTEMDATES_END_OF_STATIC, TABLEID_SYSTEMDATES
    Case Is = CLASSID_RETURNCODE
        CreateCidLookup.Initialise FID_RETURNCODE_END_OF_STATIC, TABLEID_RETURNCODE
    Case Is = CLASSID_PRICEOVERRIDE
        CreateCidLookup.Initialise FID_PRICEOVERRIDE_END_OF_STATIC, TABLEID_PRICEOVERRIDE
    Case Is = CLASSID_STOCKLOG
        CreateCidLookup.Initialise FID_STOCKLOG_END_OF_STATIC, TABLEID_STOCKLOG
    Case Is = CLASSID_ISTINHEADER
        CreateCidLookup.Initialise FID_ISTINHEADER_END_OF_STATIC, TABLEID_ISTINHEADER
    Case Is = CLASSID_STOCKTAKE
        CreateCidLookup.Initialise FID_STOCKTAKE_END_OF_STATIC, TABLEID_STOCKTAKE
    Case Is = CLASSID_RETNOTEHEADER
        CreateCidLookup.Initialise FID_RETNOTEHEADER_END_OF_STATIC, TABLEID_RETNOTEHEADER
    Case Is = CLASSID_PARAMETER
        CreateCidLookup.Initialise FID_PARAMETER_END_OF_STATIC, TABLEID_PARAMETER
    Case Is = CLASSID_WORKSTATIONCONFIG
        CreateCidLookup.Initialise FID_WORKSTATIONCONFIG_END_OF_STATIC, TABLEID_WORKSTATIONCONFIG
    Case Is = CLASSID_USER
        CreateCidLookup.Initialise FID_USER_END_OF_STATIC, TABLEID_USER
    Case Is = CLASSID_RETAILEROPTIONS
        CreateCidLookup.Initialise FID_RETAILEROPTIONS_END_OF_STATIC, TABLEID_RETAILEROPTIONS
    Case Is = CLASSID_SYSTEMOPTIONS
        CreateCidLookup.Initialise FID_SYSTEMOPTIONS_END_OF_STATIC, TABLEID_SYSTEMOPTIONS
    Case Is = CLASSID_COUNTEDSKU
        CreateCidLookup.Initialise FID_COUNTEDSKU_END_OF_STATIC, TABLEID_COUNTEDSKU
    Case Is = CLASSID_RETURNNOTE
        CreateCidLookup.Initialise FID_RETURNNOTE_END_OF_STATIC, TABLEID_RETURNNOTE
    Case Is = CLASSID_RETURNNOTELINE
        CreateCidLookup.Initialise FID_RETURNNOTELINE_END_OF_STATIC, TABLEID_RETURNNOTELINE
    'Case Is = CLASSID_DELNOTENARRATIVE
    '    CreateCidLookup.Initialise FID_DELNOTENARRATIVE_END_OF_STATIC, TABLEID_DELNOTENARRATIVE
    Case Is = CLASSID_SALETOTALS
        CreateCidLookup.Initialise FID_SALETOTALS_END_OF_STATIC, TABLEID_SALETOTALS
    Case Is = CLASSID_CASHIERTOTALS
        CreateCidLookup.Initialise FID_CASHIERTOTALS_END_OF_STATIC, TABLEID_CASHIERTOTALS
    Case Is = CLASSID_TILLTOTALS
        CreateCidLookup.Initialise FID_TILLTOTALS_END_OF_STATIC, TABLEID_TILLTOTALS
    Case Is = CLASSID_ISTINEDIHEADER
        CreateCidLookup.Initialise FID_ISTINEDIHEADER_END_OF_STATIC, TABLEID_ISTINEDIHEADER
    Case Is = CLASSID_ISTINEDILINE
        CreateCidLookup.Initialise FID_ISTINEDILINE_END_OF_STATIC, TABLEID_ISTINEDILINE
    Case Is = CLASSID_PURCHASECONSLINE
        CreateCidLookup.Initialise FID_PURCHASECONSLINE_END_OF_STATIC, TABLEID_PURCHASECONSLINE
    Case Is = CLASSID_INVENTORYINFO
        CreateCidLookup.Initialise FID_INVENTORYINFO_END_OF_STATIC, TABLEID_INVENTORYINFO
    Case Is = CLASSID_STOCKADJREASON
        CreateCidLookup.Initialise FID_STOCKADJREASON_END_OF_STATIC, TABLEID_STOCKADJREASON
    Case Is = CLASSID_ACTIVITYLOG
        CreateCidLookup.Initialise FID_ACTIVITYLOG_END_OF_STATIC, TABLEID_ACTIVITYLOG
    Case Is = CLASSID_STORESTATUS
        CreateCidLookup.Initialise FID_STORESTATUS_END_OF_STATIC, TABLEID_STORESTATUS
    Case Is = CLASSID_EDIFILECONTROL
        CreateCidLookup.Initialise FID_EDIFILECONTROL_END_OF_STATIC, TABLEID_EDIFILECONTROL
    Case Is = CLASSID_SALESLEDGER
        CreateCidLookup.Initialise FID_SALESLEDGER_END_OF_STATIC, TABLEID_SALESLEDGER
    Case Is = CLASSID_TCFMASTER
        CreateCidLookup.Initialise FID_TCFMASTER_END_OF_STATIC, TABLEID_TCFMASTER
    Case Is = CLASSID_CASHBALANCECONTROL
        CreateCidLookup.Initialise FID_CASHBALANCECONTROL_END_OF_STATIC, TABLEID_CASHBALANCECONTROL
    Case Is = CLASSID_CASHBALANCESUMMARY
        CreateCidLookup.Initialise FID_CASHBALANCESUMMARY_END_OF_STATIC, TABLEID_CASHBALANCESUMMARY
    Case Is = CLASSID_STOCKLEVEL
        CreateCidLookup.Initialise FID_STOCKLEVEL_END_OF_STATIC, TABLEID_STOCKLEVEL
    Case Is = CLASSID_POLINES
        CreateCidLookup.Initialise FID_POLINES_END_OF_STATIC, TABLEID_POLINES
    Case Is = CLASSID_OPENDRAWERCODE
        CreateCidLookup.Initialise FID_OPENDRAWERCODE_END_OF_STATIC, TABLEID_OPENDRAWERCODE
    Case Is = CLASSID_PAIDINCODE
        CreateCidLookup.Initialise FID_PAIDINCODE_END_OF_STATIC, TABLEID_PAIDINCODE
    Case Is = CLASSID_PAIDOUTCODE
        CreateCidLookup.Initialise FID_PAIDOUTCODE_END_OF_STATIC, TABLEID_PAIDOUTCODE
    Case Is = CLASSID_SALESCUSTOMER
        CreateCidLookup.Initialise FID_SALESCUSTOMER_END_OF_STATIC, TABLEID_SALESCUSTOMER
    Case Is = CLASSID_EDICHANGECODE
        CreateCidLookup.Initialise FID_EDICHANGECODE_END_OF_STATIC, TABLEID_EDICHANGECODE
    Case Is = CLASSID_EDIDELHEADER
        CreateCidLookup.Initialise FID_EDIDELHEADER_END_OF_STATIC, TABLEID_EDIDELHEADER
    Case Is = CLASSID_EDIDELLINE
        CreateCidLookup.Initialise FID_EDIDELLINE_END_OF_STATIC, TABLEID_EDIDELLINE
    Case Is = CLASSID_EDIPOLINES
        CreateCidLookup.Initialise FID_EDIPOLINES_END_OF_STATIC, TABLEID_EDIPOLINES
    Case Is = CLASSID_EDIPOEARLY
        CreateCidLookup.Initialise FID_EDIPOEARLY_END_OF_STATIC, TABLEID_EDIPOEARLY
    Case Is = CLASSID_EDIPOLATE
        CreateCidLookup.Initialise FID_EDIPOLATE_END_OF_STATIC, TABLEID_EDIPOLATE
    Case Is = CLASSID_EDIPOQTYDISCREPANCY
        CreateCidLookup.Initialise FID_EDIPOQTYDISCREPANCY_END_OF_STATIC, TABLEID_EDIPOQTYDISCREPANCY
    Case Is = CLASSID_EDIPOQTYDISCREPANCYLINES
        CreateCidLookup.Initialise FID_EDIPOQTYDISCREPANCYLINES_END_OF_STATIC, TABLEID_EDIPOQTYDISCREPANCYLINES
    Case Is = CLASSID_TRANSACTION_DISCOUNT
        CreateCidLookup.Initialise FID_TRANSACTION_DISCOUNT_END_OF_STATIC, TABLEID_TRANSACTION_DISCOUNT
    Case Is = CLASSID_GROSSMARGINS
        CreateCidLookup.Initialise FID_GROSSMARGINS_END_OF_STATIC, TABLEID_GROSSMARGINS
    'Case Is = CLASSID_ITEMMESSAGES
    '    CreateCidLookup.Initialise FID_ITEMMESSAGES_END_OF_STATIC, TABLEID_ITEMMESSAGES
    Case Is = CLASSID_CARDINFO
        CreateCidLookup.Initialise FID_CARDINFO_END_OF_STATIC, TABLEID_CARDINFO
    Case Is = CLASSID_OPMASTER
        CreateCidLookup.Initialise FID_OPMASTER_END_OF_STATIC, TABLEID_OPMASTER
    Case Is = CLASSID_OPHEADER
        CreateCidLookup.Initialise FID_OPHEADER_END_OF_STATIC, TABLEID_OPHEADER
    Case Is = CLASSID_OPMIXMATCH
        CreateCidLookup.Initialise FID_OPMIXMATCH_END_OF_STATIC, TABLEID_OPMIXMATCH
    Case Is = CLASSID_OPDEALGROUP
        CreateCidLookup.Initialise FID_OPDEALGROUP_END_OF_STATIC, TABLEID_OPDEALGROUP
    Case Is = CLASSID_CASHIERCASHBAL
        CreateCidLookup.Initialise FID_CASHIERCASHBAL_END_OF_STATIC, TABLEID_CASHIERCASHBAL
    Case Is = CLASSID_PRICECUSINFO
        CreateCidLookup.Initialise FID_PRICECUSINFO_END_OF_STATIC, TABLEID_PRICECUSINFO
    Case Is = CLASSID_POSEVENTLINE
        CreateCidLookup.Initialise FID_POSEVENTLINE_END_OF_STATIC, TABLEID_POSEVENTLINE
    Case Is = CLASSID_PRICELINEINFO
        CreateCidLookup.Initialise FID_PRICELINEINFO_END_OF_STATIC, TABLEID_PRICELINEINFO
    Case Is = CLASSID_HIERARCHYCATEGORY
        CreateCidLookup.Initialise FID_HIERARCHYCATEGORY_END_OF_STATIC, TABLEID_HIERARCHYCATEGORY
    Case Is = CLASSID_HIERARCHYGROUP
        CreateCidLookup.Initialise FID_HIERARCHYGROUP_END_OF_STATIC, TABLEID_HIERARCHYGROUP
    Case Is = CLASSID_HIERARCHYSUBGROUP
        CreateCidLookup.Initialise FID_HIERARCHYSUBGROUP_END_OF_STATIC, TABLEID_HIERARCHYSUBGROUP
    Case Is = CLASSID_HIERARCHYSTYLE
        CreateCidLookup.Initialise FID_HIERARCHYSTYLE_END_OF_STATIC, TABLEID_HIERARCHYSTYLE
    Case Is = CLASSID_INVENTORYWICKES
        CreateCidLookup.Initialise FID_INVENTORYWICKES_END_OF_STATIC, TABLEID_INVENTORYWICKES
    Case Is = CLASSID_POSMISSINGEAN
        CreateCidLookup.Initialise FID_POSMISSINGEAN_END_OF_STATIC, TABLEID_POSMISSINGEAN
    Case Is = CLASSID_REFUNDCODE
        CreateCidLookup.Initialise FID_REFUNDCODE_END_OF_STATIC, TABLEID_REFUNDCODE
    Case Is = CLASSID_TENDEROVERRIDE
        CreateCidLookup.Initialise FID_TENDEROVERRIDE_END_OF_STATIC, TABLEID_TENDEROVERRIDE
    Case Is = CLASSID_ZREADS
        CreateCidLookup.Initialise FID_ZREADS_END_OF_STATIC, TABLEID_ZREADS
    Case Is = CLASSID_POSGIFTVOUCHERS
        CreateCidLookup.Initialise FID_POSGIFTVOUCHERS_END_OF_STATIC, TABLEID_POSGIFTVOUCHERS
    Case Is = CLASSID_CUSTORDERHEADER
        CreateCidLookup.Initialise FID_CUSTORDERHEADER_END_OF_STATIC, TABLEID_CUSTORDERHEADER
    Case Is = CLASSID_CUSTORDERLINE
        CreateCidLookup.Initialise FID_CUSTORDERLINE_END_OF_STATIC, TABLEID_CUSTORDERLINE
    Case Is = CLASSID_GIFTVOUCHERHOTFILE
        CreateCidLookup.Initialise FID_GIFTVOUCHERHOTFILE_END_OF_STATIC, TABLEID_GIFTVOUCHERHOTFILE
    Case Is = CLASSID_EVENTHSEXCLUSIONS
        CreateCidLookup.Initialise FID_EVENTHSEXCLUSIONS_END_OF_STATIC, TABLEID_EVENTHSEXCLUSIONS
    Case Is = CLASSID_COLLEAGUECARDHOTFILE
        CreateCidLookup.Initialise FID_COLLEAGUECARDHOTFILE_END_OF_STATIC, TABLEID_COLLEAGUECARDHOTFILE
    Case Is = CLASSID_QUOTEHEADER
        CreateCidLookup.Initialise FID_QUOTEHEADER_END_OF_STATIC, TABLEID_QUOTEHEADER
    Case Is = CLASSID_QUOTELINE
        CreateCidLookup.Initialise FID_QUOTELINE_END_OF_STATIC, TABLEID_QUOTELINE
    Case Is = CLASSID_CUSTOMER
        CreateCidLookup.Initialise FID_CUSTOMER_END_OF_STATIC, TABLEID_CUSTOMER
    Case Is = CLASSID_WEBEVENT
        CreateCidLookup.Initialise FID_WEBEVENT_END_OF_STATIC, TABLEID_WEBEVENT
    Case Is = CLASSID_WEBHEADER
        CreateCidLookup.Initialise FID_WEBHEADER_END_OF_STATIC, TABLEID_WEBHEADER
    Case Is = CLASSID_WEBLINE
        CreateCidLookup.Initialise FID_WEBLINE_END_OF_STATIC, TABLEID_WEBLINE
    Case Is = CLASSID_WEBPICK
        CreateCidLookup.Initialise FID_WEBPICK_END_OF_STATIC, TABLEID_WEBPICK
    Case Is = CLASSID_WEBPAID
        CreateCidLookup.Initialise FID_WEBPAID_END_OF_STATIC, TABLEID_WEBPAID
    Case Is = CLASSID_PROMPT
        CreateCidLookup.Initialise FID_PROMPT_END_OF_STATIC, TABLEID_PROMPT
    Case Is = CLASSID_GROUP_PROMPT
        CreateCidLookup.Initialise FID_GROUP_PROMPT_END_OF_STATIC, TABLEID_GROUP_PROMPT
    Case Is = CLASSID_ITEM_GRPPROMPT
        CreateCidLookup.Initialise FID_ITEM_GRPPROMPT_END_OF_STATIC, TABLEID_ITEM_GRPPROMPT
    Case Is = CLASSID_PIM_ITEM
        CreateCidLookup.Initialise FID_PIM_ITEM_END_OF_STATIC, TABLEID_PIM_ITEM
    Case Is = CLASSID_COLLEAGUECARD
        CreateCidLookup.Initialise FID_COLLEAGUECARD_END_OF_STATIC, TABLEID_COLLEAGUECARD
    Case Is = CLASSID_TEMPFIL
        CreateCidLookup.Initialise FID_TEMPFIL_END_OF_STATIC, TABLEID_TEMPFIL
    Case Is = CLASSID_CURRENCY
        CreateCidLookup.Initialise FID_CURRENCY_END_OF_STATIC, TABLEID_CURRENCY
    Case Is = CLASSID_EXCHANGE_RATE
        CreateCidLookup.Initialise FID_EXCHANGE_RATE_END_OF_STATIC, TABLEID_EXCHANGERATE
    Case Is = CLASSID_WEEE_RATE
        CreateCidLookup.Initialise FID_WEEE_RATE_END_OF_STATIC, TABLEID_WEEE_RATE
    Case Is = CLASSID_PLANGRAM
        CreateCidLookup.Initialise FID_PLANGRAM_END_OF_STATIC, TABLEID_PLANGRAM
    Case Is = CLASSID_BARCODEFAILED
        CreateCidLookup.Initialise FID_BARCODEFAILED_END_OF_STATIC, TABLEID_BARCODEFAILED
    Case Is = CLASSID_EAN_CHECK
        CreateCidLookup.Initialise FID_EAN_CHECK_END_OF_STATIC, TABLEID_EAN_CHECK
    Case Is = CLASSID_TRANREJECT
        CreateCidLookup.Initialise FID_TRANREJECT_END_OF_STATIC, TABLEID_TRANREJECT
    Case Is = CLASSID_LINEREVERSAL
        CreateCidLookup.Initialise FID_LINEREVERSAL_END_OF_STATIC, TABLEID_LINEREVERSAL
    Case Is = CLASSID_DTF_SEND
        CreateCidLookup.Initialise FID_DTF_SEND_END_OF_STATIC, TABLEID_DTF_SEND
    Case Is = CLASSID_DISCOUNTCARD_SCHEME_ID
        CreateCidLookup.Initialise FID_DISCOUNTCARD_SCHEME_ID_END_OF_STATIC, TABLEID_CARD_SCHEME
    Case Is = CLASSID_DISCOUNTCARD_LIST
        CreateCidLookup.Initialise FID_DISCOUNTCARD_LIST_END_OF_STATIC, TABLEID_CARD_LIST
    Case Is = CLASSID_ORDERTEXT
        CreateCidLookup.Initialise FID_ORDERTEXT_END_OF_STATIC, TABLEID_ORDERTEXT
    Case Is = CLASSID_CUSTORDERINFO
        CreateCidLookup.Initialise FID_CUSTORDERINFO_END_OF_STATIC, TABLEID_CUSTORDERINFO
    Case Is = CLASSID_SUPPLIERDET
        CreateCidLookup.Initialise FID_SUPPLIERDET_END_OF_STATIC, TABLEID_SUPPLIERDET
    Case Is = CLASSID_MARKDOWNSTOCK
        CreateCidLookup.Initialise FID_MARKDOWNSTOCK_END_OF_STATIC, TABLEID_MARKDOWNSTOCK
    Case Is = CLASSID_CONRESHEADER
        CreateCidLookup.Initialise FID_CONRESHEADER_END_OF_STATIC, TABLEID_CONRESHEADER
    Case Is = CLASSID_CONRESDETAIL
        CreateCidLookup.Initialise FID_CONRESDETAIL_END_OF_STATIC, TABLEID_CONRESDETAIL
    Case Is = CLASSID_COUPONFMT
        CreateCidLookup.Initialise FID_COUPONFMT_END_OF_STATIC, TABLEID_COUPONFMT
    Case Is = CLASSID_SOLDCOUPON
        CreateCidLookup.Initialise FID_SOLDCOUPON_END_OF_STATIC, TABLEID_SOLDCOUPON
    Case Is = CLASSID_DAYPRICE
        CreateCidLookup.Initialise FID_DAYPRICE_END_OF_STATIC, TABLEID_DAYPRICE
    Case Is = CLASSID_COUPONTEXT
        CreateCidLookup.Initialise FID_COUPONTEXT_END_OF_STATIC, TABLEID_COUPONTEXT
    Case Is = CLASSID_POSPAYMENTCOMM
        CreateCidLookup.Initialise FID_POSPAYMENTCOMM_END_OF_STATIC, TABLEID_POSPAYMENTCOMM
    Case Is = CLASSID_CUST_REFUND
        CreateCidLookup.Initialise FID_CUST_REFUND_END_OF_STATIC, TABLEID_CUST_REFUND
    Case Else
        Set CreateCidLookup = Nothing
        Err.Raise OASYS_ERR_BO_CLASS_INCOMPLETE, "CBoDatabase::CreateCidLookup()", _
                "CBoDatabase::CreateCidLookup()" & vbCrLf & "No Cid Lookup for Class Id: " & nClassId
    End Select
End Function

'----------------------------------------------------------------------------

Public Property Get Version() As String
    Version = App.Major & "." & App.Minor & "." & App.Revision & "." & 0
End Property

Private Sub Class_Terminate()
    If Not (m_oConnection Is Nothing) Then
        If Connection.State = adStateOpen Then
            Connection.Close
        End If
        Set m_oConnection = Nothing
    End If
End Sub

'----------------------------------------------------------------------------
' Default interface
'----------------------------------------------------------------------------
Private Function Initialise(oSession As ISession, oSysRoot As ISysRoot, oEnterprise As IEnterprise) As IBoDatabase
    
    Set m_oSession = oSession
    Set m_oRoot = m_oSession.Root
    Set m_oSysRoot = oSysRoot
    Set m_oEnterprise = oEnterprise
    
    m_eLastError = DbErrorTypeNoError
    
    ' Don't assume that we have a connection object.
    On Error GoTo AdoErrorLite
       
    If (m_oSession.IsOnline = True) Then 'try to go online
    '    Connection.CursorLocation = adUseClient
        Connection.Open DefaultDSN
        If (Connection.State = adStateOpen) Then
            ' If successful, we return an IBoDatabase interface
            Set Initialise = Me
            m_oSession.IsOnline = True
            
            Dim rs As New ADODB.Recordset
            
            Set rs = Connection.Execute("Exec SystemGetParameter 4600")
            If rs.BOF = False Then
                m_retryLimit = rs.Fields("LongValue")
            Else
                m_retryLimit = 0
            End If

            Set rs = Nothing
        Else
            Debug.Assert False
        End If
        Exit Function
    End If

AdoErrorLite:

    If m_oSession.IsInteractive Then
        If (Err.Number = ADO_ERR_Connect_Failed) Or (m_oSession.IsOnline = False) Then
            If (InStr(UCase(Err.Description), "SERVER NOT FOUND") > 0) Or (InStr(UCase(Err.Description), "CONNECTION ATTEMPT TIMED OUT") > 0) Or (m_oSession.IsOnline = False) Then
                Call Err.Clear
                If MsgBox("Server not available - Do you wish to work offline", vbYesNo, "Online Server not available") = vbNo Then
                    Exit Function
                Else
                    On Error Resume Next
                    Connection.Open OfflineDSN
                    If (Connection.State = adStateOpen) Then
                        ' If successful, we return an IBoDatabase interface
                        Set Initialise = Me
                        m_oSession.IsOnline = False
                    Else
                        If (m_oSession.IsInteractive) And (Err.Number = ADO_ERR_Connect_Failed) Then
                            MsgBox "Failed to find or connect to Offline database DSN: " & OfflineDSN & vbCrLf & "System will exit", vbCritical
                        End If
                        Debug.Assert False
                    End If
                    Exit Function
                End If
            End If
            MsgBox "Failed to find or connect to database DSN: " & DefaultDSN & vbCrLf & "Err:" & Err.Number & "-" & Err.Description
            
        Else
            Dim strTmp As String
            ' Get VB Error Object's information - shouldn't get here!
            strTmp = strTmp & vbCrLf & "VB Error # " & CStr(Err.Number)
            strTmp = strTmp & vbCrLf & "   Generated by " & Err.Source
            strTmp = strTmp & vbCrLf & "   Description  " & Err.Description
            
            MsgBox strTmp
        End If
    End If
    
    ' Clean up gracefully without risking infinite loop in error handler
    On Error GoTo 0
    Resume Next
           
End Function
Private Function UpdateFromRow(RowOfFields As IRow, Optional bCreateIfAbsent As Boolean) As Boolean
    
'    Dim arrHandlers() As IHandler
'    ReDim arrHandlers(0)
'
'    Debug.Assert Not (m_oSession Is Nothing)
'
'    ' Set up a handler for each table referenced in the row
'    GetHandlersFromRow RowOfFields, arrHandlers
'
'    ' We now have handlers set up for all tables invoked by selectors.
'    UpdateFromRow = (arrHandlers(0) Is Nothing)
'    If arrHandlers(0) Is Nothing Then
'        Debug.Assert False
'    Else
'        UpdateFromRow = arrHandlers(0).UpdateRow(RowOfFields)
'    End If
            
End Function

Private Function SaveFromRow(eSave As enSaveType, RowOfFields As IRow, _
        ByRef RowOfChanges As IRow) As Boolean
    ' We update the database according to eSave, with the data to be saved
    ' given by RowOfFields.  If there is any data created by this action,
    ' for example and autoincrement field, then it is returned in RowOfChanges.
    ' If no returned data, then RowOfChanges is Nothing.
    
    Dim arrHandlers() As IHandler
    
    ReDim arrHandlers(0)
    
    Debug.Assert Not (m_oSession Is Nothing)
    
    ' Set up a handler for each table referenced in the row
    Call GetHandlersFromRow(RowOfFields, arrHandlers)
    
    ' We now have handlers set up for all tables invoked by fields.
    SaveFromRow = (arrHandlers(0) Is Nothing)
    If arrHandlers(0) Is Nothing Then
        Debug.Assert False
    Else
        m_eLastError = arrHandlers(0).SaveFromRow(eSave, RowOfFields, RowOfChanges)
        SaveFromRow = (m_eLastError = DbErrorTypeNoError)
    End If
            
End Function

Private Function SaveBo(eSave As enSaveType, ByVal oIBo As IBo) As Boolean
    ' Note that oIBo is ByVal so we don't change the user's interface to the Bo.

Dim oRowOfChanges   As IRow
Dim oSysBo As ISysBo
    
    Debug.Assert Not (oIBo Is Nothing)
    
    SaveBo = False
    On Error GoTo SaveBo_Error
    ' Ask the object if it is valid and so in a consistent state to save
    If oIBo.IsValid() Then
        SaveBo = SaveFromRow(eSave, oIBo.GetAllFieldsAsRow(), oRowOfChanges)
        If Not (oRowOfChanges Is Nothing) Then
            ' We have some fields that have changed and need setting into the Bo
            Set oSysBo = oIBo
            oSysBo.LoadFromRow oRowOfChanges
        End If
    End If
    Exit Function
    
SaveBo_Error:
    ' Simply return false
    ' Note that this method assumes the proposed oBo.IBo_GetAllFieldsAsRow()
    ' method is supported.
    Debug.Assert False
    
End Function

Public Function DeleteBoCollection(RowSelector As IRowSelector) As Boolean
    ' The selector determines which Bos comprise the collection for
    ' deletion from persistent storage
Dim arrHandlers()   As IHandler
    
    ReDim arrHandlers(0)
    
    Debug.Assert Not (m_oSession Is Nothing)
    
    ' Set up a handler for each table referenced in the selector

    GetHandlersFromSelector RowSelector, arrHandlers
    
    ' We now have handlers set up for all tables invoked by fields.
    DeleteBoCollection = (arrHandlers(0) Is Nothing)
    If arrHandlers(0) Is Nothing Then
        Debug.Assert False
    Else
        m_eLastError = arrHandlers(0).DeleteBoCollection()
        DeleteBoCollection = (m_eLastError = DbErrorTypeNoError)
    End If
            
End Function

Private Function SavePartialBo(ByVal oIBo As IBo, oRow As IRow) As Boolean
    ' This is potentially dangerous.  We want to update just SOME of the property
    ' values from the Bo to the Db, leaving other propery values unchanged in the Db.
    ' If there is no Key field(s) then the generated SQL won't have the proper WHERE
    ' and the SQL execute will fail.  But we validate that all fields in the row
    ' are recognised by the Bo.
    ' Note that oIBo is ByVal so we don't change the user's interface to the Bo.
Dim oField          As IField
Dim oGField         As CFieldGroup
Dim i               As Integer
Dim nSubscript      As Integer
Dim oNewRow         As IRow
Dim oRowOfChanges   As IRow         ' Potential changes returned by the Db
    
    Debug.Assert Not (oIBo Is Nothing)
    
    SavePartialBo = True
    Set oNewRow = New CRow
    ' Ensure we use the standard IBo interface using oIBo
    For i = 1 To oRow.Count
        ' for each field
        Set oField = oRow.Field(i)
        ' Get the FID and thence the field Value from the Bo
        If oIBo.GetField(oField.Id) Is Nothing Then
            ' Unrecognised FID
            Debug.Assert False
            SavePartialBo = False
            Exit For
        Else
            ' FID ok, so add the field value from the Bo
            oNewRow.Add oIBo.GetField(oField.Id)
            If oField.FieldType = FieldTypeGroup Then
                ' We have a group field, so do we need replicate the subscript?
                Set oGField = oField
                nSubscript = oGField.Subscript
                If nSubscript > 0 Then
                    ' Yes, we must set the subscript in the last field added to oRow
                    Set oGField = oNewRow.Field(oNewRow.Count)
                    oGField.Subscript = nSubscript
                End If
            End If
        End If
    Next i
    
    If SavePartialBo Then
        ' All Fields are valid, so ...
        ' simply save the row to the Db, but only if there is already a record there!
        SavePartialBo = SaveFromRow(SaveTypeIfExists, oNewRow, oRowOfChanges)
        If Not (oRowOfChanges Is Nothing) Then
            ' We have some fields that have changed and need setting into the Bo
            Dim oSysBo As ISysBo
            Set oSysBo = oIBo
            oSysBo.LoadFromRow oRowOfChanges
        End If
    End If
    
    Set oNewRow = Nothing
    
End Function

Public Function GetView(RowSelector As IRowSelector, Optional SortKeys As IBoSortKeys) As IView

Dim i As Integer
Dim j As Integer
Dim bIsSelected As Boolean
Dim oColumnAsField As IField
Dim arrHandlers() As IHandler
    
    ReDim arrHandlers(0)

    Debug.Assert Not (m_oSession Is Nothing)
    Set GetView = Nothing
    
    ' Set up a handler for each table referenced in the selector
    GetHandlersFromSelector RowSelector, arrHandlers, SortKeys

    If Not (arrHandlers(0) Is Nothing) Then
        ' We now have handlers set up for all tables invoked by selectors.
        ' So get a recordset for the primary table, select the rows required
        ' and create an initial CView, all rows but just primary field values.
        
        Set GetView = arrHandlers(0).CreatePrimaryView
        
        ' We have the initial CView populated with rows of primary data
        
        If UBound(arrHandlers) > 0 Then
            ' We have at least one secondary, so process each row in the view
            For i = 1 To GetView.Count
                ' Process each Row in the primary view
                For j = 1 To UBound(arrHandlers)
                    ' for each secondary handler
                    If Not arrHandlers(j).BuildRow(GetView.Row(i)) Then
                        Debug.Assert False
                    End If
                Next j
            Next i
        End If
    End If
    
    ' Tidy up
    For j = 0 To UBound(arrHandlers)
        Set arrHandlers(j) = Nothing
    Next j
    
End Function

Private Function GetSelectView(oRow As IRowSelector, Optional RowSelector As IRowSelector, Optional SortKeys As IBoSortKeys) As String

    Dim j As Integer
    Dim arrHandlers() As IHandler
    ReDim arrHandlers(0)

    Debug.Assert Not (m_oSession Is Nothing)
    GetSelectView = vbNullString
    
    'if no Where clause then make a dummy one using the Source Field as a select all
'    If RowSelector Is Nothing Then
'        Set RowSelector = m_oSession.Root.CreateUtilityObject("CRowSelector")
'        Call RowSelector.AddSelectAll(oField.IField_Id)
'    End If
    
    ' Set up a handler for each table referenced in the selector
    Call GetHandlersFromSelector(RowSelector, arrHandlers, SortKeys)

    If Not (arrHandlers(0) Is Nothing) Then
        ' We now have handlers set up for all tables invoked by selectors.
        ' So get a recordset for the primary table, select the rows required
        ' and create an initial CView, all rows but just primary field values.
        
        GetSelectView = arrHandlers(0).CreateSelectSQL(oRow)
        
    End If
    
    ' Tidy up
    For j = 0 To UBound(arrHandlers)
        Set arrHandlers(j) = Nothing
    Next j
    
End Function

Public Function GetLiteralView(RowSelector As IRowSelector, _
                               DataFormat As Long, _
                               sLineSeparator As String, _
                               sDataSeparator As String, _
                               sTextDelim As String) As String

Dim arrHandlers()  As IHandler
Dim strView        As String
Dim lngHandler     As Long
    
    ReDim arrHandlers(0)

    GetLiteralView = vbNullString
    
    ' Set up a handler for each table referenced in the selector
    Call GetHandlersFromSelector(RowSelector, arrHandlers)

    If Not (arrHandlers(0) Is Nothing) Then
        ' We now have handlers set up for all tables invoked by selectors.
        ' So get a recordset for the primary table, select the rows required
        ' and create an initial CView, all rows but just primary field values.
        
        strView = arrHandlers(0).CreateLiteralView(DataFormat, sLineSeparator, sDataSeparator, sTextDelim)
        
    End If
    
    ' Tidy up
    For lngHandler = 0 To UBound(arrHandlers)
        Set arrHandlers(CLng(lngHandler)) = Nothing
    Next lngHandler
    
    GetLiteralView = strView
    
End Function

Public Function GetBoCollection(RowSelector As IRowSelector, Optional SortKeys As IBoSortKeys) As Collection
    
    Dim oView As IView
    Dim oBo As IBo
    Dim i As Integer
    Dim j As Integer
    Debug.Assert Not (m_oSession Is Nothing)
    Set GetBoCollection = New Collection
    Set oView = GetView(RowSelector, SortKeys)
    If Not (oView Is Nothing) Then
        For i = 1 To oView.Count
            Set oBo = m_oSysRoot.CreateBoFromRow(oView.Row(i), m_oSession)
            GetBoCollection.Add oBo
'            Debug.Print "i=" & i; " "; oBo.IBo_DebugString
        Next i
    End If
End Function

Private Function GetHandlersFromSelector(RowSelector As IRowSelector, ByRef arrHandlers() As IHandler, _
                                        Optional SortKeys As IBoSortKeys)
    ' Examine the row selector and build up an array of handlers to return.
    Dim i           As Integer
    Dim j           As Integer
    Dim oFSelector  As IFieldSelector
    Dim oField      As IField
    Dim nClassId    As Integer
    ' oCidLookup is effectively the Business Object Data Service
    Dim oCidLookup  As CCidLookup
    Dim nTmpCid     As Long
    Dim nTmpTableId As Integer
    Dim bFound      As Boolean
    Dim bRetOk      As Boolean
    
    If Not (RowSelector Is Nothing) Then
        ' Ensure is not nothing
        If RowSelector.Count > 0 Then
            ' and there is at least one field selector
            Set oFSelector = RowSelector.FieldSelector(1)
            ' Check the first field, which must be a key field
            Set oField = oFSelector.Field
            nClassId = oField.Id \ &H10000
            bRetOk = True
            If (oField.Id And &H7FFF) = 1 Then
                bRetOk = True
            End If
        End If
    End If
    If Not bRetOk Then
        ' We have a problem, so lets get outta here.
        Debug.Assert False
        Exit Function
    End If
    
    ' Everything looks valid if we get here.
    
    ' Set up the CidLookup object (effectively the Business Object data service)
    Set oCidLookup = CidLookup(nClassId)
    ' Set up a handler for each table referenced in the selector
    ReDim arrHandlers(0)
    For i = 1 To RowSelector.Count
        ' for each selector
        Set oFSelector = RowSelector.FieldSelector(i)
        Set oField = oFSelector.Field
        nTmpCid = oCidLookup.Cid(oField.Id)
        nTmpTableId = nTmpCid \ &H10000
        bFound = False
        For j = 0 To UBound(arrHandlers)
            ' for each handler
            If arrHandlers(j) Is Nothing Then
                j = j - 1
                Exit For
            End If
            If arrHandlers(j).TableId = nTmpTableId Then
                bFound = True
                Exit For
            End If
        Next j
        If Not bFound Then
            ' No handler for this guy, so lets create one and add to our list
            j = j + 1
            ReDim Preserve arrHandlers(j)
            Set arrHandlers(j) = New CTableHandler
            Dim initTable As ITable
            Dim initConnection As Connection
            Dim initSortKeys As IBoSortKeys
            
            Set initTable = Table(nTmpTableId)
            Set initConnection = Connection
            Set initSortKeys = SortKeys
            arrHandlers(j).Initialise Table(nTmpTableId), Me, SortKeys
        End If
        arrHandlers(j).AddSelector oFSelector
    Next i
    
    ' Tidy up
    Set oFSelector = Nothing
    Set oField = Nothing
End Function

Private Function GetHandlersFromRow(Row As IRow, ByRef arrHandlers() As IHandler)
    ' Examine the row selector and build up an array of handlers to return.
    ' There is a row for fields rather than a row selector and so we create
    ' a default selector in which the key matches the row key values.
    Dim i           As Integer
    Dim j           As Integer
    Dim oField      As IField
    Dim nClassId    As Integer
    ' oCidLookup is effectively the Business Object Data Service
    Dim oCidLookup  As CCidLookup
    Dim nTmpCid     As Long
    Dim nTmpTableId As Integer
    Dim nKeyCount   As Integer
    Dim bFound      As Boolean
    Dim bRetOk      As Boolean
    Dim oFSelector  As IFieldSelector
    
    If Not (Row Is Nothing) Then
        ' Ensure is not nothing
        If Row.Count > 0 Then
            ' and there is at least one field
            ' Check the first field, which must be a key field
            Set oField = Row.Field(1)
            nClassId = oField.Id \ &H10000
            If (oField.Id And &H7FFF) = 1 Then
                bRetOk = True
            End If
        End If
    End If
    If Not bRetOk Then
        ' We have a problem, so lets get outta here.
        Debug.Assert False
        Exit Function
    End If
    
    ' Everything looks valid if we get here.
'    Set oFSelector = New CFieldSelector
'    oFSelector.Initialise CMP_EQUAL, oField.Interface, True  ' default selector is = key value
   
    
    ' Set up the CidLookup object (effectively the Business Object data service)
    Set oCidLookup = CidLookup(nClassId)
    ' Set up a handler for each table referenced in the row
    ReDim arrHandlers(0)
    For i = 1 To Row.Count
        ' for each field
        Set oField = Row.Field(i)
        nTmpCid = oCidLookup.Cid(oField.Id)
        nTmpTableId = nTmpCid \ &H10000
        bFound = False
        For j = 0 To UBound(arrHandlers)
            ' for each handler
            If arrHandlers(j) Is Nothing Then
                j = j - 1
                Exit For
            End If
            If arrHandlers(j).TableId = nTmpTableId Then
                bFound = True
                Exit For
            End If
        Next j
        If Not bFound Then
            ' No handler for this guy, so lets create one and add to our list
            j = j + 1
            ReDim Preserve arrHandlers(j)
            Set arrHandlers(j) = New CTableHandler
            arrHandlers(j).Initialise Table(nTmpTableId), Me
            nKeyCount = Table(nTmpTableId).KeyCount
            ' Allow for implicit key being first FID
            If nKeyCount = 0 Then nKeyCount = 1
        End If
        If j = 0 And ((oField.Id And &H7FFF) <= nKeyCount) Then
            ' we have a primary key, so add to the default selector
            Set oFSelector = New CFieldSelector
            oFSelector.Initialise CMP_EQUAL, oField.Interface, True  ' default selector is = key value
            arrHandlers(0).AddSelector oFSelector
        End If
    Next i
    
    ' Tidy up
    Set oField = Nothing
End Function

Private Property Get Connection() As Connection
    If m_oConnection Is Nothing Then
        If m_oRoot.IsRunningAsWebServer Then
            ' as a web app we may need to do a Server.CreatObject()
            Debug.Assert False
            Set m_oConnection = CreateObject("adodb.connection")
        Else
            ' Not a web app so a simple createobject will do.
            Set m_oConnection = CreateObject("adodb.connection")
        End If
        If m_oConnection Is Nothing Then
            Debug.Assert False
            Err.Raise OASYS_ERR_NO_DB_CONNECTION, "CBoDatabase::Connection()", _
                    "CBoDatabase::Connection()" & vbCrLf & "Could not create a connection to the database."
        End If
    End If
    Set Connection = m_oConnection
End Property
Private Property Get ConnectionString() As String

    If ((m_oConnection Is Nothing) = False) Then ConnectionString = m_oConnection.ConnectionString

End Property
Private Property Get DefaultDSN() As String
    
Dim strKey, strValue As String
Dim nResult As Long
Dim oRegistry As OASYSCBASECOMLib.Registry
    
    Set oRegistry = m_oRoot.CreateUtilityObject("Registry")
    If Not (oRegistry Is Nothing) Then
        strKey = RelativeRegistryKey
        oRegistry.GetCTSStringValue strKey, "DSN", strValue, nResult
        If nResult = 0 Then
            DefaultDSN = strValue
            Debug.Print "Database for Enterprise " & m_oEnterprise.Id & " DSN from registry: " & DefaultDSN
        End If
    End If
    If LenB(DefaultDSN) = 0 Then
        ' Mnemonic not set so use a default
        DefaultDSN = "Oasys"
        Debug.Print "Database (default) for Enterprise " & m_oEnterprise.Id & " DSN from registry: " & DefaultDSN
    End If
    Set oRegistry = Nothing

End Property

Private Property Get OfflineDSN() As String
    
Dim strKey, strValue As String
Dim nResult As Long
Dim oRegistry As OASYSCBASECOMLib.Registry
    
    Set oRegistry = m_oRoot.CreateUtilityObject("Registry")
    If Not (oRegistry Is Nothing) Then
        strKey = RelativeRegistryKey
        oRegistry.GetCTSStringValue strKey, "OfflineDSN", strValue, nResult
        If nResult = 0 Then
            OfflineDSN = strValue
            Debug.Print "Database for Enterprise " & m_oEnterprise.Id & " Offline DSN from registry: " & DefaultDSN
        End If
    End If
    If LenB(OfflineDSN) = 0 Then
        ' Mnemonic not set so use a default
        OfflineDSN = "OasysOffline"
        Debug.Print "Database (default) for Enterprise " & m_oEnterprise.Id & " Offline DSN from registry: " & DefaultDSN
    End If
    Set oRegistry = Nothing

End Property

Private Property Get RelativeRegistryKey() As String
    RelativeRegistryKey = m_oEnterprise.RelativeRegistryKey & "\Database"
End Property

Private Property Get CidLookup(nClassId As Integer) As CCidLookup
    If nClassId <= UBound(m_arrCidLookup) Then
        Set CidLookup = m_arrCidLookup(nClassId)
        If CidLookup Is Nothing Then
            Set CidLookup = CreateCidLookup(nClassId)
            If CidLookup Is Nothing Then
                Debug.Assert False
            End If
            Set m_arrCidLookup(nClassId) = CidLookup
        End If
    Else
        ' subscript out of range!
        Debug.Assert False
    End If
End Property

Private Property Get Table(nTableId As Integer) As CTable
    Dim nTableSub As Integer
    ' Assert we have a table Id
    Debug.Assert (nTableId And TABLE_FLAG) <> 0
    nTableSub = nTableId Xor TABLE_FLAG
    If (nTableSub) <= UBound(m_arrTables) Then
        Set Table = m_arrTables(nTableSub)
        If Table Is Nothing Then
            Set Table = CreateTable(nTableId)
            If Table Is Nothing Then
                Debug.Assert False
            End If
            Set m_arrTables(nTableSub) = Table
        End If
    Else
        ' subscript out of range!
        Debug.Assert False
    End If
End Property

Private Function CreateBusinessObject(nClassId As Integer, Optional oOptSysBo As ISysBo) As IBo
    Dim oDefault    As IBo
    Dim oBo         As IBo
    Dim oSysBo      As ISysBo
    ' Create object
    Set oBo = m_oSysRoot.CreateUninitialisedBusinessObject(nClassId, oSysBo)
    If oBo Is Nothing Then
        Debug.Assert False      ' Create failed
    Else
        Set oDefault = oBo.Initialise(m_oSession)
        If oDefault Is Nothing Then
            Err.Raise OASYS_ERR_INCONSISTENT_OBJECT, "CBoDatabase::CreateBusinessObject()", "Requested Object Id " & nClassId & " Initialise returning Nothing"
        End If
        If nClassId <> oBo.ClassId Then
            Err.Raise OASYS_ERR_INCONSISTENT_OBJECT, "CBoDatabase::CreateBusinessObject()", "Requested Object Id " & nClassId & " but got " & oBo.ClassId
        End If
        Set CreateBusinessObject = oDefault
        If Not (IsMissing(oOptSysBo)) Then
            Set oOptSysBo = oSysBo
        End If
        Debug.Print "Created object Ok, ClassId: " & oBo.ClassId & " " & oBo.ClassName
    End If
End Function

Public Function CreateBoSelector(Optional nInFieldId As Long, Optional nComparator As Long, Optional Value As Variant) As IRowSelector
' To create:
'   1. an empty Row selector, simply pass no parameters
' To select for:
'   2. All Bos for a ClassId, all properties, simply pass a Class Id
'   3. Incomplete selector for a ClassId, one property, simply pass the field Id
'   4. All Bos for a ClassId, key property, simply pass key field Id
'      and the SelectAll comparator.  You can later add other properties
'      to the selector to load just the ones you want.
'   5. A particular Bo or selection of Bos, simply pass the appropriate
'      FieldId, comparator and value.
    Dim oBo         As IBo
    Dim nClassId    As Integer
    Dim nFieldId    As Long
    ' bIsClass = true if we were passed a class ID or false if passed a field Id
    Dim bIsClass    As Boolean
    nFieldId = nInFieldId
    nClassId = nFieldId \ &H10000
    If nClassId = 0 Then
        ' We can only assume we have been passed a class Id rather than a Field Id
        bIsClass = True
        nClassId = nFieldId
        ' We were passed a ClassId so we must work out a FieldId, lets use #1 and hope it is the key
        nFieldId = (nClassId * &H10000) + 1
    End If
'    Set CreateBoSelector = m_oRoot.CreateUtilityObject("CRowSelector")
    Set CreateBoSelector = New CRowSelector
    ' Initialise the selector ourselves
    Set CreateBoSelector.SysRoot = m_oSysRoot
    Set oBo = m_oSysRoot.GetStaticBoFromCid(nClassId)
    If Not (oBo Is Nothing) Then
        ' We have a valid field, so its not option 1.
        If nComparator = CMP_INVALID Then
            ' No comparator, so its option 2 or 3. - select all properties
            If bIsClass Then
                ' Its option 2. - select all properties
                Set CreateBoSelector = oBo.GetSelectAllRow
            Else
                ' Its option 3. - select one property, default comparator
                ' Note that the result is an incomplete BoSelector
                CreateBoSelector.AddSelectAll nFieldId
            End If
        Else
            If nComparator = CMP_SELECTALL Then
                ' Its option 4. - select one property
                CreateBoSelector.AddSelectAll nFieldId
            Else
                If IsMissing(Value) Then
                    ' We have no value passed to compare against!
                    Debug.Assert False
                Else
                    ' Its option 5. - specific comparator
'                    Set oField = m_oSysRoot.CreateFieldFromFid(nFieldId)
'                    CreateBoSelector.AddSelection nComparator, oField
                    CreateBoSelector.AddSelectValue nComparator, nFieldId, Value
                End If
            End If
        End If
    End If
End Function

Private Static Function CreateBoFromRow(oRow As IRow) As ISysBo
    ' Note we return the default object interface, Not the IBo interface.
    Dim nClassId    As Integer
    Dim oSysBo      As ISysBo
    If oRow Is Nothing Then
        Debug.Assert False
        Set CreateBoFromRow = Nothing
    Else
        ' oRow is valid, so we can now use it
        nClassId = oRow.Field(1).Id \ &H10000
        Set CreateBoFromRow = CreateBusinessObject(nClassId, oSysBo)
        If Not (CreateBoFromRow Is Nothing) Then
            oSysBo.LoadFromRow oRow
        End If
    End If
End Function

Private Function IBoDatabase_CommitTransaction() As Boolean
    
    Call m_oConnection.CommitTrans
    IBoDatabase_CommitTransaction = True

End Function

Private Property Get IBoDatabase_ConnectionString() As String

    IBoDatabase_ConnectionString = ConnectionString
    
End Property

Private Function IBoDatabase_DeleteFromRow(RowSelector As IRowSelector) As Boolean

End Function

Private Function IBoDatabase_GetAggregateValue(nFunctionId As Integer, oField As IField, RowSelector As IRowSelector) As Variant

Dim nRecNo As Integer
Dim arrHandlers() As IHandler
    
    ReDim arrHandlers(0)

    IBoDatabase_GetAggregateValue = Null
    
    'if no Where clause then make a dummy one using the Source Field as a select all
    If RowSelector Is Nothing Then
        Set RowSelector = m_oSession.Root.CreateUtilityObject("CRowSelector")
        Call RowSelector.AddSelectAll(oField.Id)
    End If
    ' Set up a handler for each table referenced in the selector
    Call GetHandlersFromSelector(RowSelector, arrHandlers)
 
    If Not (arrHandlers(0) Is Nothing) Then
        IBoDatabase_GetAggregateValue = arrHandlers(0).GetAggregateValue(nFunctionId, oField)
    End If
    
    ' Tidy up
    For nRecNo = 0 To UBound(arrHandlers)
        Set arrHandlers(nRecNo) = Nothing
    Next nRecNo
    
End Function

Public Function IBoDatabase_DoBulkUpdate(oTarget As Object, oSource As Object, oRowSelector As IRowSelector) As Boolean
' This routine requires the target class to support the IsBulkUpdateValid() method.
' Target and Source are either both IField objects or both CRow objects
' If the FID for target and source are the same, then the source provides the value,
' otherwise the source provides the FID.
Dim oBo             As IBo
Dim oTargetField    As IField
Dim oSourceField    As IField
Dim nTargetCID      As Integer
Dim nSelectorCID    As Integer
Dim arrHandlers()   As IHandler
    
    ReDim arrHandlers(0)
    
    On Error Resume Next
    Set oTargetField = oTarget
    On Error GoTo IBoDatabase_DoBulkUpdate_Error
    
    If oTargetField Is Nothing Then
        ' We have been passed CRows and NOT IFields
        Set oTargetField = oTarget.Field(1)
    End If
    
    Set oBo = m_oSysRoot.GetStaticBoFromCid(oTargetField.Id \ &H10000)
    
    Debug.Assert Not (oBo Is Nothing)
    ' Check that the row and selector are for the same Class Id
    nTargetCID = oTargetField.Id \ &H10000
    nSelectorCID = oRowSelector.FieldSelector(1).Field(1).Id \ &H10000
    If nTargetCID = nSelectorCID Then
        ' Class Id match ok.
        ' Get native i/f and assume there is a method IsBulkUpdateValid()
        Dim o As Object ' VERY Special Case
        Set o = oBo.Interface
        If o.IsBulkUpdateValid(oTarget, oSource, oRowSelector) Then
           ' Set up a handler for each table referenced in the selector
           Call GetHandlersFromSelector(oRowSelector, arrHandlers)
        
           If Not (arrHandlers(0) Is Nothing) Then
               IBoDatabase_DoBulkUpdate = arrHandlers(0).DoBulkUpdate(oTarget, oSource)
           End If
        Else
            ' The class forbids us from doing this update
            Debug.Assert False
        End If
    Else
        ' Class Id for Target and selector don't match, nonsensical update!
        Debug.Assert False
    End If
    
    Exit Function
    
IBoDatabase_DoBulkUpdate_Error:
    Debug.Assert False

End Function


Private Function IBoDatabase_GetLiteralView(RowSelector As IRowSelector, DataFormat As Long, sLineSeparator As String, sDataSeparator As String, sTextDelim As String) As String

    IBoDatabase_GetLiteralView = GetLiteralView(RowSelector, DataFormat, sLineSeparator, sDataSeparator, sTextDelim)

End Function

Public Function IBoDatabase_GetSelectView(oRow As IRowSelector, Optional RowSelector As IRowSelector) As String
    IBoDatabase_GetSelectView = GetSelectView(oRow, RowSelector)
End Function

Private Function IBoDatabase_RollbackTransaction() As Boolean
    
    Call m_oConnection.RollbackTrans
    IBoDatabase_RollbackTransaction = True

End Function

Private Function IBoDatabase_StartTransaction() As Boolean

    Call m_oConnection.BeginTrans
    IBoDatabase_StartTransaction = True

End Function

'----------------------------------------------------------------------------
' IBoDatabase interface
'----------------------------------------------------------------------------
Public Property Get IBoDatabase_Version() As String
    IBoDatabase_Version = Version
End Property

Public Function IBoDatabase_Initialise(oSession As ISession, oSysRoot As ISysRoot, oEnterprise As IEnterprise) As IBoDatabase
    Set IBoDatabase_Initialise = Initialise(oSession, oSysRoot, oEnterprise)
End Function
Public Function IBoDatabase_GetView(RowSelector As IRowSelector) As IView
    Set IBoDatabase_GetView = GetView(RowSelector)
End Function
Public Function IBoDatabase_GetBoCollection(RowSelector As IRowSelector) As Collection
    Set IBoDatabase_GetBoCollection = GetBoCollection(RowSelector)
End Function
Public Function IBoDatabase_GetSortedBoCollection(RowSelector As IRowSelector, SortKeys As IBoSortKeys) As Collection
    Set IBoDatabase_GetSortedBoCollection = GetBoCollection(RowSelector, SortKeys)
End Function
Public Function IBoDatabase_GetBo(RowSelector As IRowSelector) As IBo

Dim coll    As Collection
    
    Set coll = GetBoCollection(RowSelector)
    If Not (coll Is Nothing) Then
        Select Case (coll.Count)
        Case 0:
            ' Return nothing as no Bo found
        Case 1:
            ' Found it!
            Set IBoDatabase_GetBo = coll.Item(1)
        Case Else:
            ' User expected selector to return one Bo (or zero if absent)
            ' so this is an error that should be catered for.
            Err.Raise OASYS_ERR_NON_UNIQUE_SELECTION, "CBoDatabase::IBoDatabase_GetBo()", _
                "CBoDatabase::IBoDatabase_GetBo()" & vbCrLf & "Selection matches more than one Business Object"
        End Select
    End If
End Function
Public Function IBoDatabase_CreateBusinessObject(nClassId As Integer) As IBo
    Set IBoDatabase_CreateBusinessObject = CreateBusinessObject(nClassId)
End Function
Public Function IBoDatabase_CreateBoSelector(Optional nFieldId As Long, Optional nComparator As Long, Optional Value As Variant) As IRowSelector
    Set IBoDatabase_CreateBoSelector = CreateBoSelector(nFieldId, nComparator, Value)
End Function
Public Static Function IBoDatabase_CreateBoFromRow(oRow As IRow) As IBo
    Set IBoDatabase_CreateBoFromRow = CreateBoFromRow(oRow)
End Function
Public Static Function IBoDatabase_SaveFromRow(eSave As enSaveType, oRow As IRow) As Boolean
    
Dim oRowOfChanges   As IRow
    
    IBoDatabase_SaveFromRow = SaveFromRow(eSave, oRow, oRowOfChanges)

End Function
Public Function IBoDatabase_SaveBo(eSave As enSaveType, oBo As IBo) As Boolean
    IBoDatabase_SaveBo = SaveBo(eSave, oBo)
End Function

Public Function IBoDatabase_DeleteBoCollection(RowSelector As IRowSelector) As Boolean
    IBoDatabase_DeleteBoCollection = DeleteBoCollection(RowSelector)
End Function

Public Property Get IBoDatabase_LastErrorType() As enDbErrorType
    IBoDatabase_LastErrorType = m_eLastError
End Property
Public Function IBoDatabase_SavePartialBo(oBo As IBo, oRow As IRow) As Boolean
    IBoDatabase_SavePartialBo = SavePartialBo(oBo, oRow)
End Function
    
    
Public Property Get IBoDatabase_Connection() As ADODB.Connection
    Set IBoDatabase_Connection = Connection
End Property

Public Function IBoDatabase_ExecuteCommand(CommandText As String, Optional RecordsAffected As Long, Optional Options As Long) As ADODB.Recordset
    
    Dim procedureName As String
    procedureName = "IBoDatabase_ExecuteCommand"

    Dim retryCount As Integer
    retryCount = 0
    
    Dim supressError As Boolean
    Dim executedSuccesfully As Boolean
    
    Do
        supressError = (retryCount < m_retryLimit)
        Set IBoDatabase_ExecuteCommand = ExecuteCommand(supressError, executedSuccesfully, CommandText, RecordsAffected, Options)
        retryCount = retryCount + 1
    Loop While Not executedSuccesfully
    
End Function

Private Function ExecuteCommand(supressError As Boolean, executedSuccesfully As Boolean, CommandText As String, Optional RecordsAffected As Long, Optional Options As Long) As ADODB.Recordset

    Dim procedureName As String
    procedureName = "ExecuteCommand"

    executedSuccesfully = False
    
    On Error GoTo ErrorHandler

    Call DebugMsg(MODULE_NAME, procedureName, endlDebug, "Before execute")
    Set ExecuteCommand = Connection.Execute(CommandText, RecordsAffected, Options)
    Call DebugMsg(MODULE_NAME, procedureName, endlDebug, "Execution successful")
    
    executedSuccesfully = True
    
    Exit Function
    
ErrorHandler:
    
    Call DebugMsg(MODULE_NAME, procedureName, endlDebug, "Error occured: " & CStr(Err.Number) & " " & Err.Description)
    
    If supressError And Err.Number = -2147217871 Then 'Timeout expired
        Call DebugMsg(MODULE_NAME, procedureName, endlDebug, "Retrying")
        Exit Function
    End If
    
    Call Err.Raise(Err.Number, Err.Source, Err.Description)

End Function


